#include<iostream>
#include<vector>
#include"gcd.h"
using namespace std;

const int MAXN=1e7;

bool sieve[MAXN+1];
vector<int> primes;

void GetPrimes(int n)
{
    if(primes.size()!=0)
    {
        return;
    }

    for(int i=0; i<=n; i++)
    {
        sieve[i]=true;
    }

    for(int i=2; i<=n; i++)
    {
        if(sieve[i])
        {
            primes.push_back(i);

            for(long long j=(long long)i*i; j<=n; j+=i)
            {
                sieve[j]=false;
            }
        }
    }

    return;
}

unsigned long long play(unsigned long long MAX_X)
{
    GetPrimes(MAXN);

    if(query(0, MAX_X+1)==MAX_X+1)
    {
        return 0;
    }

    long long x=1;
    for(int p:primes)
    {
        if(p>MAX_X)
        {
            break;
        }

        long long pow=1;
        while(pow<2*MAX_X)
        {
            pow*=p;
        }
        pow/=p;

        unsigned long long res=query(0, pow);
        //cout << pow << " - " << res << "\n";

        x*=res;
    }

    return x;
}
