#include<iostream>
#include<vector>
#include<cmath>
using namespace std;

const int MAXN=1e5, LOGN=ceil(log2(2*MAXN));

vector<int> graph[MAXN];
int d[MAXN], pos[MAXN], rmq[2*MAXN][LOGN], ans[MAXN], c[MAXN];
vector<int> order;

void DFS(int idx, int pr)
{
    pos[idx]=order.size();
    order.push_back(idx);

    for(int node:graph[idx])
    {
        if(node!=pr)
        {
            d[node]=d[idx]+1;
            ans[node]=ans[idx];

            if(c[node]!=c[idx])
            {
                ans[node]++;
            }

            DFS(node, idx);
            order.push_back(idx);
        }
    }

    return;
}

void PrepRMQ()
{
    int n=order.size();
    for(int i=0; i<n; i++)
    {
        rmq[i][0]=order[i];
    }

    int logn=ceil(log2(n));
    for(int j=1; j<=logn; j++)
    {
        for(int i=0; i<n; i++)
        {
            if(i+(1LL<<j)>n)
            {
                continue;
            }

            if(d[rmq[i][j-1]]<d[rmq[i+(1<<(j-1))][j-1]])
            {
                rmq[i][j]=rmq[i][j-1];
            }
            else
            {
                rmq[i][j]=rmq[i+(1<<(j-1))][j-1];
            }
        }
    }

    return;
}

int GetRMQ(int a, int b)
{
    if(a>b)
    {
        swap(a, b);
    }

    int k=(b-a+1);
    int logk=log2(k);

    if(d[rmq[a][logk]]<d[rmq[b-(1<<logk)+1][logk]])
    {
        return rmq[a][logk];
    }

    return rmq[b-(1<<logk)+1][logk];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n-1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    for(int i=0; i<n; i++)
    {
        cin >> c[i];
    }

    d[0]=0, ans[0]=0;
    DFS(0, -1);
    PrepRMQ();

    int q;
    cin >> q;

    while(q--)
    {
        int t, a, b;
        cin >> t >> a >> b;
        a--, b--;

        int lcm=GetRMQ(pos[a], pos[b]);
        cout << ans[a]+ans[b]-2*ans[lcm] << "\n";
    }

    return 0;
}
/*
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
3
3 6 5
3 1 6
3 4 5
*/
