#include<iostream>
#include<vector>
#include<tuple>
#include<map>
#include<algorithm>
using namespace std;

const int LETTERS=15, MAXP=LETTERS*LETTERS, MOD=1e9+7;

vector<pair<string, char> > q;
long long prs[MAXP], temp[MAXP], cnt[26];

map<char, char> mp, rmp;

string Compress(string s)
{
    vector<char> v;
    for(char c:s)
    {
        v.push_back(c);
    }
    sort(v.begin(), v.end());

    int n=v.size();
    char c='A';
    for(int i=0; i<n; i++)
    {
        if(i==0 || v[i]!=v[i-1])
        {
            mp[v[i]]=c;
            rmp[c]=v[i];
            c++;
        }
    }

    for(int i=0; i<n; i++)
    {
        s[i]=mp[s[i]];
    }

    return s;
}

int GetNum(string s)
{
    int a=s[0]-'A';
    int b=s[1]-'A';

    return a*LETTERS+b;
}

string GetPair(char a, char b)
{
    string s="";
    s=s+a;
    s=s+b;

    return s;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    for(int i=0; i<MAXP; i++)
    {
        prs[i]=0, temp[i]=0;
    }

    for(int i=0; i<LETTERS; i++)
    {
        cnt[i]=0;
    }

    string seq;
    cin >> seq;

    //seq=Compress(seq);

    int ss=seq.size();
    for(int i=0; i<ss-1; i++)
    {
        prs[GetNum(GetPair(seq[i], seq[i+1]))]++;
        cnt[(int)(seq[i]-'A')]++;
    }
    cnt[(int)(seq[ss-1]-'A')]++;

    int n, m;
    cin >> n >> m;

    for(int i=0; i<m; i++)
    {
        string s;
        cin >> s;

        char c;
        cin >> c;

        q.push_back({s, c});
    }

    while(n--)
    {
        for(pair<string, char> p:q)
        {
            string s=p.first;
            char c=p.second;

            int nums=GetNum(s), numc=(int)(c-'A'), p1=GetNum(GetPair(s[0], c)), p2=GetNum(GetPair(c, s[1]));
            cnt[numc]=(cnt[numc]+prs[nums])%MOD;
            temp[nums]=(temp[nums]-prs[nums]+MOD)%MOD;
            temp[p1]=(temp[p1]+prs[nums])%MOD;
            temp[p2]=(temp[p2]+prs[nums])%MOD;
        }

        for(int i=0; i<MAXP; i++)
        {
            prs[i]=(prs[i]+temp[i]+MOD)%MOD;
            temp[i]=0;
        }
    }

    for(char c='A'; c<='Z'; c++)
    {
        cout << c << " " << cnt[(int)(c-'A')] << "\n";
    }

    return 0;
}

