#include "gcd.h"

#include <iostream>
#include <random>

static const size_t NUM_TRIALS = 4e4;

static ull MAX_X;
static ull MAX_AB;
static ull SEED;

static ull x;

static std::mt19937 generator;
static void generateNumber()
{
    std::uniform_long long_distribution<ull> distribution(0, MAX_X - 1);
    x = distribution(generator);
}

static ull numQueries;

ull query(ull a, ull b)
{
    if (a < 0 || b <= 0 || a >= MAX_AB || b >= MAX_AB)
    {
        std::cout << "Invalid A or B." << std::endl;
        exit(0);
    }

    ++numQueries;

    a += x;
    while (b != 0)
    {
        ull temp = b;
        b = a % b;
        a = temp;
    }

    return a;
}

static void verifyGuess(ull guess)
{
    if (guess != x)
    {
        std::cout << "Wrong guess." << std::endl;
        exit(0);
    }
}
long long otg=1,prosti[MAX_N],st[MAX_N];
bool pp[MAX_N];
void pri(long long n) {
    for(long long i=2; i<=MAX_N/n; i++) {
        pp[2*n]=1;
    }
    for(long long i=n+1; i<=MAX_N;i++) {
        if(pp[i]==0) {
            pri(pp[i]);
            break;
        }
    }
}
long long poww(long long a,long long b) {
    long long ot=poww(a,b/2);
    ot=ot*ot;
    if(b%2==1) {
        ot=ot*a;
    }
    return ot;
}
void pr(long long p, long long MAX_X) {
    long long br=1;
    while(poww(p,br)<=MAX_N) {
        br++;
    }
    st[p]=br;
}
ull play(ull MAX_X) {
    long long otgovor=1;
    if(pp[4]==0) {
        pri(2);
        for(long long i=2; i<=MAX_N; i++) {
            if(pp[i]==0) {
                pr(p,MAX_N);
            }
        }
    }
    for(long long i=2; i<=MAX_N; i++) {
            if(pp[i]==0) {
                otgovor=otgovor*query(0,st[i]);
            }
    }
    return otgovor;

}

int main()
{
    std::cin >> MAX_X >> SEED;

    MAX_AB = MAX_X * 2;
    generator.seed(SEED);
    for (size_t i = 0; i < NUM_TRIALS; ++i)
    {
        generateNumber();
        ull guess = play(MAX_X);
        verifyGuess(guess);
    }

    double averageQueries = (long double) numQueries / NUM_TRIALS;
    std::cout << "Average queries: " << averageQueries << std::endl;

    return 0;
}
