#include <iostream>
#include <vector>
#include <algorithm>
#include <limits.h>
#include <stdio.h>
#include <queue>
#include <stack>

using namespace std;

int n,Q;
int colors[100010];
vector<int> gr[100010];
int lp[100010];
int lpIndex[100010];
int colorIndex[100010];
int dal[100010];
int par[100010];
bool used[100010];
int LastLazyIndex=1;

void BFS()
{
	queue<pair<int,int> >q;
	q.push({1,0});
	pair<int,int> curr;
	used[1]=true;
	while(!q.empty())
	{
		curr=q.front();
		dal[curr.first]=curr.second;
		q.pop();
		for(int i=0;i<gr[curr.first].size();i++)
		{
			if(!used[gr[curr.first][i]])
			{
				used[gr[curr.first][i]]=true;
				q.push({gr[curr.first][i],curr.second+1});
				par[gr[curr.first][i]]=curr.first;
			}
		}
	}
//	for(int i=1;i<=n;i++)
//		cout<<i<<" - "<<dal[i]<<endl;
//	for(int i=1;i<=n;i++)
//		cout<<i<<" - "<<par[i]<<endl;
}

void init()
{
	int a,b;
	cin>>n;
	for(int i=0;i<n-1;i++)
	{
		scanf("%d%d",&a,&b);
		gr[a].push_back(b);
		gr[b].push_back(a);
	}

	for(int i=1;i<=n;i++)
		scanf("%d",&colors[i]);
//	fill(dal,dal+(n+5),-1);
//	dal[1]=0;	
//	fill(par,par+(n+5),-1);
//	par[1]=1;
//	fill(lp,lp+(n+5),-1);
//	fill(lpIndex,lpIndex+(n+5),-1);
	BFS();
}

void colorSubtree(int Node,int color)
{
	int node=Node;
	stack<int> path;
	int currColor=-1;
	int currIndex=-1;
	while(node!=1)
	{
		path.push(node);
		node=par[node];
	}
	path.push(1);
	while(!path.empty())
	{
		node=path.top();
		path.pop();
		if(lp[node]!=-1)
		{
			if(lpIndex[node]>currIndex)
			{
				currColor=lp[node];
				currIndex=lpIndex[node];
			}
			else 
			{
				lp[node]=-1;
				lpIndex[node]=-1;
			}
		}
		if(colorIndex[node]<currIndex)
		{
			colors[node]=currColor;	
			colorIndex[node]=-1;
		}
	}
	colors[Node]=color;
	lp[Node]=color;
	lpIndex[Node]=LastLazyIndex;
	LastLazyIndex++;
}

void colorPath(int From,int To,int Color)
{
	int d1=dal[From],d2=dal[To];
	int curr1=From,curr2=To;
	stack<int> path1,path2;
	if(d1<d2)
	{
		swap(d1,d2);
		swap(curr1,curr2);
	}
	path1.push(curr1);
	path2.push(curr2);
		
	while(curr1!=curr2)
	{
		while(d1>d2)
		{
			curr1=par[curr1];
			d1=dal[curr1];
			path1.push(curr1);
		}
		if(curr1!=curr2)
		{
			curr2=par[curr2];
			d2=dal[curr2];
			path2.push(curr2);
		}
	}
	while(!path1.empty())
	{
		curr1=path1.top();
		path1.pop();
		colors[curr1]=Color;
		colorIndex[curr1]=LastLazyIndex;
	}
	while(!path2.empty())
	{
		curr2=path2.top();
		colors[curr2]=Color;
		colorIndex[curr2]=LastLazyIndex;
		path2.pop();
	}	
	LastLazyIndex++;
}

pair<int,int> UpdatePath(stack<int> path,int LP,int LPI)
{
	int Curr;
	while(!path.empty())
	{
		Curr=path.top();
		path.pop();
		if(lpIndex[Curr]>LP)
		{
			LP=lp[Curr];
			LPI=lpIndex[Curr];
		}
		if(LP!=-1)
		{
			if(LPI>colorIndex[Curr])
			{
				colorIndex[Curr]=-1;
				colors[Curr]=LP;
			}
		}
	}
	return {LP,LPI};
}

int Count(int start,int end)
{
	int currColor;
	int Total=0;
	currColor=start;
	while(start!=end)
	{		
		start=par[start];
		if(colors[currColor]!=colors[start])Total++;

		currColor=start;
	}
	return Total;
}

int FindColorShifts(int From,int To)
{
	int d1=dal[From],d2=dal[To];
	int curr1=From,curr2=To;
	stack<int> path1,path2;
	if(d1<d2)
	{
		swap(d1,d2);
		swap(curr1,curr2);
	}
	path1.push(curr1);
	path2.push(curr2);
		
	while(curr1!=curr2)
	{
		while(d1>d2)
		{
			curr1=par[curr1];
			d1=dal[curr1];
			path1.push(curr1);
		}
		if(curr1!=curr2)
		{
			curr2=par[curr2];
			d2=dal[curr2];
			path2.push(curr2);
		}
	}	
	int Common=curr1;
	int Color=-1,LP=-1,LPI=-1,CI=-1;
	stack<int> Path;
	int Curr=Common;
	while(Curr!=1)
	{
		Path.push(Curr);
		Curr=par[Curr];
	}

	Path.push(1);
	pair<int,int> result=UpdatePath(Path,LP,LPI);
	LP=result.first;
	LPI=result.second;
	UpdatePath(path1,LP,LPI);
	UpdatePath(path2,LP,LPI);
	//cout<<Count(From,Common)<<"  "<<Count(To,Common)<<endl;
	return Count(From,Common)+Count(To,Common);
}



int solve()
{
	int indicator,a,b,c;
	scanf("%d",&Q);
	for(int i=0;i<Q;i++)
	{
		scanf("%d%d%d",&indicator,&a,&b);
		if(indicator==1)scanf("%d",&c);
		switch(indicator)
		{
			case 1:colorPath(a,b,c);break;
			case 2:colorSubtree(a,b);break;
			case 3:cout<<FindColorShifts(a,b)<<endl;break;
		};
	}
}

int main()
{
	init();
	solve();
//	DFS(1,-1,-1);
//	fill(USED,USED+(n+5),false);
//	PRINT(1);
}
/*
15
1 2
1 5 
1 6
2 3
2 4
4 8
5 9
9 12
9 11
6 7
7 15
7 10
10 13
10 14
1 1 3 2 1 2 1 1 3 2 5 1 4 4 3
4
2 10 8
2 1 5
1 15 6 6
2 7 7 


12
1 2 
2 3
3 4
4 5
5 9
9 11
4 7
7 10 
10 12
3 6
2 8
1 2 1 2 1 1 4 3 2 2 1 4 
3
2 2 9
1 6 1 2
3 11 12

*/
