#include "gcd.h"
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
typedef unsigned long long ull;

const ull MAXN = 1000000003;

vector<ull> primes;
int sz = 0;

void init(ull from = 2, ull to = MAXN)
{
    for (ull i = from; i <= to; ++i)
    {
        bool is_prime = 1;
        for (int j = 0; j < sz; ++j)
            if (i % primes[j] == 0)
            {
                is_prime = 0;
                break;
            }

        if (is_prime)
        {
            primes.push_back(i);
            ++sz;
        }
    }
}

ull query(ull a, ull b);

ull play(ull MAX_X)
{
    ull lim = ((int)sqrt(MAX_X));
//    cout << lim << endl;

    init(2, lim);
    ull ret = 1;
    bool not_null = 0;
    ull curr = 1;

//    for (int i = 0; i < sz; ++i)
//        cout << primes[i] << " ";
//    cout << endl;

    ull check = query(0, MAX_X + 1);
    if (check == MAX_X + 1)
        return 0;

    for (int i = 0; i < sz; ++i)
    {
        ull tmp = 1;
        if (ret * primes[i] > MAX_X)
        //if (ret > MAX_X)
        {
            //cout << "ret: " << ret << ", prime: " << primes[i] << endl;
            break;
        }
        while (tmp * primes[i] < MAX_X)
            tmp *= primes[i];

        ull q = query(0, tmp);
        //cout << tmp << " " << primes[i] << " " << q << endl;
        //cout << primes[i] << " " << tmp << endl;

        if (tmp != q)
            not_null = 1;

        ret *= q;

        if (ret == MAX_X)
            return MAX_X;

        if (ret > MAX_X)
        {
            return 0;
        }
    }

    //cout << ret << endl;
    ull upper = MAX_X / ret;
    //cout << "upp: " << upper << endl;

    for (ull i = lim + 1; i <= upper; ++i)
    {
        if (i * ret > MAX_X)
        {
            //cout << "ret: " << ret << ", tmp: " << i << endl;
            break;
        }

        bool is_prime = 1;
        for (int j = 0; j < sz; ++j)
        {
            if (i % primes[j] == 0)
            {
                is_prime = 0;
                break;
            }
        }

        if (is_prime)
        {
            primes.push_back(i);
            ++sz;

            ull tmp = 1;
            while (tmp * i < MAX_X * 2)
                tmp *= i;

            ull q = query(0, tmp);

            if (tmp != q)
                not_null = 1;

            ret *= q;

            if (ret == MAX_X)
                return MAX_X;

            if (ret > MAX_X)
            {
                return 0;
            }
        }
    }

    //cout << ret << endl;
    return ret;
}

//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//    cout.tie(NULL);
//
//
//    return 0;
//}
