#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 100003;
const int MAXL = 17;
int n, q;
vector<int> adj[MAXN];
int clr[MAXN];
int sz[MAXN];
int par[MAXN][MAXL];
int st[MAXN], en[MAXN];
int dfs_time = 0;
int LOG;
int pending[MAXN];
int cnt[MAXN];

void input()
{
    cin >> n;
    LOG = log2(n);

    for (int i = 0; i < n - 1; ++i)
    {
        int from, to;
        cin >> from >> to;
        adj[from].push_back(to);
        adj[to].push_back(from);
    }

    for (int i = 1; i <= n; ++i)
        cin >> clr[i];
}

void dfs_lca(int tmp, int prev = -1)
{
    for (int i = 1; i <= LOG; ++i)
        par[tmp][i] = par[ par[tmp][i - 1] ][i - 1];

    for (auto nb: adj[tmp])
        if (nb != prev)
        {
            par[nb][0] = tmp;
            dfs_lca(nb, tmp);
        }
}

int dfs_sz(int tmp, int prev = -1)
{
    st[tmp] = dfs_time++;
    sz[tmp] = 1;
    for (auto nb: adj[tmp])
        if (nb != prev)
            sz[tmp] += dfs_sz(nb, tmp);

    en[tmp] = dfs_time++;
    return sz[tmp];
}

void dfs_init(int u, int prev = -1)
{
    cnt[u] = 0;
    if (prev != -1)
    {
        cnt[u] += cnt[prev];
        if (clr[u] != clr[prev])
            ++cnt[u];
    }

    for (auto nb: adj[u])
        if (nb != prev)
            dfs_init(nb, u);
}

bool is_upper(int u, int v)
{
    return st[u] <= st[v] && en[u] >= en[v];
}

int get_lca(int u, int v)
{
    if (is_upper(u, v))
        return u;
    if (is_upper(v, u))
        return v;

    for (int i = LOG; i >= 0; --i)
        if (!is_upper(par[u][i], v))
            u = par[u][i];

    return par[u][0];
}

void print_info()
{
    for (int i = 1; i <= n; ++i)
    {
//        cout << endl;
        cout << i << ": " << endl;
//        cout << st[i] << " - " << en[i] << endl;
        for (int j = 0; j <= LOG; ++j)
            cout << par[i][j] << endl;
    }
}

void push(int u)
{
    if (!pending[u])
        return;

    clr[u] = pending[u];
    for (auto nb: adj[u])
        pending[nb] = pending[u];

    pending[u] = 0;
}

void update_path(int u, int v, int lca)
{
    int tmp = u;
    stack<int> st;
    while (par[tmp][0] != tmp)
    {
        st.push(tmp);
        tmp = par[tmp][0];
    }

    while (!st.empty())
    {
        tmp = st.top();
        st.pop();

        push(tmp);
    }

    tmp = v;
    while (tmp != lca)
    {
        st.push(tmp);
        tmp = par[tmp][0];
    }

    while (!st.empty())
    {
        tmp = st.top();
        st.pop();

        push(tmp);
    }
}

void query1(int u, int v, int c)
{
    int lca = get_lca(u, v);

    //update_path(u, v, lca);

    for (;;)
    {
        clr[v] = c;
        v = par[v][0];
        if (v == lca)
            break;
    }

    for (;;)
    {
        clr[u] = c;
        u = par[u][0];
        if (u == lca)
            break;
    }
}

void query2(int u, int c, int prev = -1)
{
    clr[u] = c;
    for (auto nb: adj[u])
        if (nb != prev)
            query2(nb, c, u);
}

int query3(int u, int v)
{
    int lca = get_lca(u, v);
    int res = 0;

//    cout << "query: " << endl;
//    cout << u << ": " << cnt[u] << endl;
//    cout << v << ": " << cnt[v] << endl;
//    cout << lca << ": " << cnt[lca] << endl;

    if (u == v)
        return 0;

    if (is_upper(u, v))
        return cnt[v] - cnt[u];

    if (is_upper(v, u))
        return cnt[u] - cnt[v];

    return cnt[u] + cnt[v] - 2 * cnt[lca];

    update_path(u, v, lca);



    int prev = u;
    for (;;)
    {
        if (u == lca)
            break;
        u = par[u][0];
        if (clr[u] != clr[prev])
            ++res;
        prev = u;
    }

    prev = v;
    for (;;)
    {
        if (v == lca)
            break;
        v = par[v][0];
        if (clr[v] != clr[prev])
            ++res;
        prev = v;
    }

    return res;
}

void solve()
{
    dfs_sz(1);
    for (int i = 0; i <= LOG; ++i)
        par[1][i] = 1;
    dfs_lca(1);
    dfs_init(1);

    //cout << "**" << endl;

    //print_info();

//    for (int i = 1; i <= n; ++i)
//        cout << i << ": " << cnt[i] << endl;

    //cout << " ** " << endl;

//    for (;;)
//    {
//        int u, v;
//        cin >> u >> v;
//        cout << get_lca(u, v) << endl;
//    }

    cin >> q;
    for (int test = 0; test < q; ++test)
    {
        int type, u, v, c;
        cin >> type;
        if (type == 1)
        {
            cin >> u >> v >> c;
            query1(u, v, c);
        }
        else if (type == 2)
        {
            cin >> u >> c;
            //pending[u] = c;
            query2(u, c, par[u][0]);
        }
        else if (type == 3)
        {
            cin >> u >> v;
            cout << query3(u, v) << endl;
        }
    }

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
