#include<bits/stdc++.h>
using namespace std;
const int MAX_N = 1e5+2;
int subtree[MAX_N], depth[MAX_N], par[MAX_N], head[MAX_N], heavy[MAX_N], s_idx[MAX_N], f_idx[MAX_N], ar[MAX_N], lazy[4*MAX_N], s_color[MAX_N];
int n,q,u0,v0,c0;
vector<int> adj[MAX_N];
struct st
{
    int left_element;
    int right_element;
    int value;
    st(){}
    st(int _left_element, int _right_element, int _value)
    {
        left_element = _left_element;
        right_element = _right_element;
        value = _value;
    }
    void update(int _left_element, int _right_element, int _value)
    {
        left_element = _left_element;
        right_element = _right_element;
        value = _value;
    }
}tree[4*MAX_N];
int dfs(int cur)
{
    subtree[cur] = 1;
    int max_subtree_sz = 0;
    for(auto x: adj[cur])
    {
        if(x == par[cur]) continue;
        depth[x] = depth[cur]+1;
        par[x] = cur;
        int child_sz = dfs(x);
        subtree[cur] += child_sz;
        if(child_sz > max_subtree_sz)
        {
            max_subtree_sz = child_sz;
            heavy[cur] = x;
        }
    }
    return subtree[cur];
}
int cur_time = 0;
void decompose(int cur, int cur_head)
{
    cur_time++;
    s_idx[cur] = cur_time;
    ar[cur_time] = cur;
    head[cur] = cur_head;
    if(heavy[cur] != 0) decompose(heavy[cur], cur_head);
    for(auto x: adj[cur])
    {
        if(x != par[cur] && x != heavy[cur])
        {
            decompose(x, x);
        }
    }
    f_idx[cur] = cur_time; /// za updeit na subtree
}
void push_lazy(int node, int tl, int tr)
{
    tree[node].update(lazy[node], lazy[node], 0);
    lazy[node] = 0;
}
st bad_return = st(0,0,0);
st left_half, right_half, to_return;
st segmentTreeQuery(int node, int tl, int tr, int l, int r)
{
    if(lazy[node]) push_lazy(node, tl, tr);
    if(tl > r || tr < l) return bad_return;
    if(tl >= l && tr <= r) return tree[node];
    int mid = (tl+tr)/2;
    st left_half = segmentTreeQuery(node*2, tl, mid, l, r);
    st right_half = segmentTreeQuery(node*2+1, mid+1, tr, l, r);
    if(left_half.left_element == 0) return right_half;
    if(right_half.left_element == 0) return left_half;
    to_return.update(left_half.left_element, right_half.right_element, left_half.value+right_half.value);
    if(left_half.right_element != right_half.left_element) to_return.value++;
    return to_return;
}
void query(int a, int b)
{
    int ans = 0;
    for( ;head[a] != head[b]; b = par[head[b]])
    {
        if(depth[head[a]] > depth[head[b]]) swap(a,b);
        st tmp = segmentTreeQuery(1,1,n,s_idx[head[b]],s_idx[s_idx[b]]);
        ans += tmp.value;
        if(segmentTreeQuery(1,1,n,s_idx[head[b]],s_idx[head[b]]).left_element != segmentTreeQuery(1,1,n,s_idx[par[head[b]]],s_idx[par[head[b]]]).left_element) ans++; /// ?
    }
    if(depth[a] > depth[b]) swap(a,b);
    ans += segmentTreeQuery(1,1,n,s_idx[a],s_idx[b]).value;
    cout<<ans<<endl;
}
void build(int node, int tl, int tr)
{
    if(tl == tr)
    {
//        cout<<"! "<<tl<<" "<<s_color[ar[tl]]<<endl;
        tree[node] = st(s_color[ar[tl]], s_color[ar[tl]], 0);
        return;
    }
    int mid = (tl+tr)/2;
    build(node*2, tl, mid);
    build(node*2+1, mid+1, tr);
    int new_val = tree[node*2].value+tree[node*2+1].value;
    if(tree[node*2].right_element != tree[node*2+1].left_element) new_val++;
    tree[node] = st(tree[node*2].left_element, tree[node*2+1].right_element, new_val);
    return;
}
void update_segment(int node, int tl, int tr, int l, int r,int new_color)
{
    if(lazy[node]) push_lazy(node,tl,tr);
    if(tl > r || tr < l) return;
    if(tl >= l && tr <= r)
    {
        tree[node] = st(new_color, new_color, 0);
        lazy[node*2] = new_color;
        lazy[node*2+1] = new_color;
        return;
    }
    int mid = (tl+tr)/2;
    update_segment(node*2, tl, mid, l, r, new_color);
    update_segment(node*2+1, mid+1, tr, l, r, new_color);
    tree[node] = st(tree[node*2].left_element, tree[node*2+1].right_element, tree[node*2].value+tree[node*2+1].value);
    if(tree[node*2].right_element != tree[node*2+1].left_element) tree[node].value++;
}
void update_path(int a, int b, int new_color)
{
    int ans = 0;
    for( ;head[a] != head[b]; b = par[head[b]])
    {
        if(depth[a] > depth[b]) swap(a,b);
        update_segment(1,1,n,s_idx[head[b]],s_idx[s_idx[b]],new_color);
    }
    if(depth[a] > depth[b]) swap(a,b);
    update_segment(1,1,n,s_idx[a],s_idx[b],new_color);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(int i=0; i<n-1; i++)
    {
        cin>>u0>>v0;
        adj[u0].push_back(v0);
        adj[v0].push_back(u0);
    }
    for(int i=1; i<=n; i++)
    {
        cin>>s_color[i];
    }
    par[1] = -1;
    dfs(1);
    decompose(1,1);
    build(1,1,n);
//    cout<<"he "<<heavy[3]<<endl;
    int type;
    cin>>q;
    for(int i=0; i<q; i++)
    {
        cin>>type;
        if(type == 1)
        {
            cin>>u0>>v0>>c0;
            update_path(u0,v0,c0);
        }
        else if(type == 2)
        {
            cin>>u0>>c0;
            update_segment(1, 1, n, s_idx[u0], f_idx[u0], c0);
        }
        else
        {
            cin>>u0>>v0;
            query(u0,v0);
        }
    }

}
/**
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
5
3 6 4
1 6 4 2
3 1 5
2 2 4
3 3 5
*/
