#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define ull unsigned long long
#define fr first
#define sc second
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 1e5 + 5;
const int MAXL = 17;

int n, q, T = 1;
pair<int, int> lift[MAXN][MAXL];
matrix<int> G;
vector<int> col, tin, tout;

void dfs(int u = 1, int p = 1){
    tin[u] = T ++;
    lift[u][0] = {p, (col[u] == col[p] ? 0 : 1)};
    for(int i = 1; i < MAXL; i ++){
        lift[u][i].fr = lift[lift[u][i - 1].fr][i - 1].fr;
        lift[u][i].sc = lift[u][i - 1].sc + lift[lift[u][i - 1].fr][i - 1].sc;
    }
    for(auto v : G[u]){
        if(v == p) continue;
        dfs(v, u);
    }
    tout[u] = T ++;
}

bool is_ancestor(int u, int v){
    return (tin[u] <= tin[v] && tout[v] <= tout[u]);
}

int get_anc(int u, int v){
    if(is_ancestor(u, v)){
        return u;
    }
    if(is_ancestor(v, u)){
        return v;
    }
    for(int i = MAXL - 1; i >= 0; i --){
        if(!is_ancestor(lift[u][i].fr, v)){
            u = lift[u][i].fr;
        }
    }
    return lift[u][0].fr;
}

int get_contr(int u, int ANC){
    if(u == ANC){
        return 0;
    }
    int ret = 0;
    for(int i = MAXL - 1; i >= 0; i --){
        if(!is_ancestor(lift[u][i].fr, ANC)){
            ret += lift[u][i].sc;
            u = lift[u][i].fr;
        }
    }
    ret += lift[u][0].sc;
    return ret;
}

int main(){
    cin >> n;
    G = matrix<int>(n + 1);
    tin = tout = col = vector<int>(n + 1);
    for(int i = 0; i < n - 1; i ++){
        int u, v; cin >> u >> v;
        G[u].pb(v);
        G[v].pb(u);
    }
    for(int i = 1; i <= n; i ++){
        cin >> col[i];
    }
    dfs();
    /**
    for(int u = 1; u <= n; u ++){
        cout << u << ": ";
        for(int i = 0; i < MAXL; i ++){
            cout << "(" << lift[u][i].fr << " " << lift[u][i].sc << ") ";
        }
        cout << endl;
    }
    */
    cin >> q;
    for(int i = 0; i < q; i ++){
        int t; cin >> t;
        if(t == 3){
            int u, v; cin >> u >> v;
            int anc = get_anc(u, v);
            cout << get_contr(u, anc) + get_contr(v, anc) << endl;
        }
    }
}
/**
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
5
3 6 4
1 6 4 2
3 1 5
2 2 4
3 3 5
*/
