#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define ull unsigned long long
#define fr first
#define sc second
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 1e5 + 5;
const int MAXL = 17;

struct Node{
    int leftmost = 0, rightmost = 0, contr = 0, lazy = 0;
    Node() {}
    Node(int val){
        leftmost = rightmost = val;
    }
    Node(int _leftmost, int _rightmost, int _contr){
        leftmost = _leftmost;
        rightmost = _rightmost;
        contr = _contr;
    }
    friend Node merge(Node a, Node b){
        if(a.leftmost == 0) return b;
        if(b.leftmost == 0) return a;
        return Node(a.leftmost, b.rightmost, a.contr + b.contr + (a.rightmost == b.leftmost ? 0 : 1));
    }
};

int n, q, T = 1, col[MAXN], sz[MAXN], pos[MAXN], head[MAXN], par[MAXN], dep[MAXN], lift[MAXN][MAXL], tin[MAXN], tout[MAXN];
Node segmtree[4 * MAXN];
matrix<int> G, F;

void push(int node, int l, int r){
    if(segmtree[node].lazy){
        segmtree[node].leftmost = segmtree[node].rightmost = segmtree[node].lazy;
        segmtree[node].contr = 0;
        if(l != r){
            segmtree[2 * node + 0].lazy = segmtree[node].lazy;
            segmtree[2 * node + 1].lazy = segmtree[node].lazy;
        }
        segmtree[node].lazy = 0;
    }
}

void upd(int node, int l, int r, int ql, int qr, int v){
    if(qr < l || r < ql){
        return;
    }
    else if(ql <= l && r <= qr){
        push(node, l, r);
        segmtree[node].lazy = v;
        push(node, l, r);
    }
    else{
        int m = (l + r) / 2;

        push(node, l, r);
        push(2 * node + 0, l + 0, m);
        push(2 * node + 1, m + 1, r);

        upd(2 * node + 0, l + 0, m, ql, qr, v);
        upd(2 * node + 1, m + 1, r, ql, qr, v);

        push(node, l, r);
        push(2 * node + 0, l + 0, m);
        push(2 * node + 1, m + 1, r);

        segmtree[node] = merge(segmtree[2 * node], segmtree[2 * node + 1]);
    }
}

void upd(int node, int l, int r, int x, int v){
    if(l == r){
        segmtree[node] = Node(v);
    }
    else{
        int m = (l + r) / 2;
        if(l <= x && x <= m) upd(2 * node + 0, l + 0, m, x, v);
        else                 upd(2 * node + 1, m + 1, r, x, v);
        segmtree[node] = merge(segmtree[2 * node], segmtree[2 * node + 1]);
    }
}

Node qry(int node, int l, int r, int ql, int qr){
    if(qr < l || r < ql){
        return Node();
    }
    else if(ql <= l && r <= qr){
        push(node, l, r);
        return segmtree[node];
    }
    else{
        int m = (l + r) / 2;
        push(node, l, r);
        return merge(qry(2 * node + 0, l + 0, m, ql, qr), qry(2 * node + 1, m + 1, r, ql, qr));
    }
}

void dfs_fix(int u = 1, int p = 1, int d = 0){
    tin[u] = T ++;

    lift[u][0] = p;
    for(int i = 1; i < MAXL; i ++){
        lift[u][i] = lift[lift[u][i - 1]][i - 1];
    }

    dep[u] = d; par[u] = p;
    for(auto v : F[u]){
        if(v == p) continue;
        G[u].pb(v);
        dfs_fix(v, u, d + 1);
    }

    tout[u] = T ++;
}

bool is_ancestor(int u, int v){
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int get_lca(int u, int v){
    if(is_ancestor(u, v)) return u;
    if(is_ancestor(v, u)) return v;
    for(int i = MAXL - 1; i >= 0; i --){
        if(!is_ancestor(lift[u][i], v)){
            u = lift[u][i];
        }
    }
    return lift[u][0];
}

void dfs_size(int u = 1){
    sz[u] = 1;
    for(auto &v : G[u]){
        dfs_size(v);
        sz[u] += sz[v];
        if(sz[v] > sz[G[u][0]]){
            swap(v, G[u][0]);
        }
    }
}

void dfs_hld(int u = 1, int h = 1){
    pos[u] = T ++; head[u] = h;
    for(auto v : G[u]){
        dfs_hld(v, (v == G[u][0] ? h : v));
    }
}

int main(){
    cin >> n;
    F = G = matrix<int>(n + 1);
    for(int i = 0; i < n - 1; i ++){
        int u, v; cin >> u >> v;
        F[u].pb(v);
        F[v].pb(u);
    }
    dfs_fix();
    dfs_size();
    T = 1; dfs_hld();

    for(int i = 1; i <= n; i ++){
        cin >> col[i];
        upd(1, 1, n, pos[i], col[i]);
    }
    for(int u = 1; u <= n; u ++) cout << pos[u] << " "; cout << endl;
    cin >> q;
    for(int i = 0; i < q; i ++){
        int t; cin >> t;
        if(t == 1){
            int u, v, c; cin >> u >> v >> c;
            int lca = get_lca(u, v);
            while(head[u] != head[lca]){
                upd(1, 1, n, pos[head[u]], pos[u], c);
                u = par[head[u]];
            }
            upd(1, 1, n, pos[lca], pos[u], c);
            while(head[v] != head[lca]){
                upd(1, 1, n, pos[head[v]], pos[v], c);
                v = par[head[v]];
            }
            upd(1, 1, n, pos[lca], pos[v], c);
        }
        if(t == 3){
            int u, v, ans = 0; cin >> u >> v;
            int lca = get_lca(u, v);
            while(head[u] != head[lca]){
                ans += qry(1, 1, n, pos[head[u]], pos[u]).contr;
                int zz = pos[head[u]];
                int yy = pos[par[head[u]]];
                if(qry(1, 1, n, zz, zz).leftmost != qry(1, 1, n, yy, yy).leftmost) ++ ans;
                u = par[head[u]];
            }
            ans += qry(1, 1, n, pos[lca], pos[u]).contr;
            while(head[v] != head[lca]){
                ans += qry(1, 1, n, pos[head[v]], pos[v]).contr;
                int zz = pos[head[v]];
                int yy = pos[par[head[v]]];
                if(qry(1, 1, n, zz, zz).leftmost != qry(1, 1, n, yy, yy).leftmost) ++ ans;
                v = par[head[v]];
            }
            ans += qry(1, 1, n, pos[lca], pos[v]).contr;
            cout << ans << endl;
        }
    }
}
/**
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
3
3 6 4
1 6 4 2
3 1 5

2
1
0

7
1 2
1 3
2 4
2 5
3 6
3 7
1 2 2 3 3 3 3
*/
