#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

int n,inp[nmax];

vector<int> adj[nmax];

int depth[nmax];

int up[20][nmax],sum[20][nmax];

int lca(int u,int v)
{
    if(depth[u]<depth[v])swap(u,v);

    for(int j=19;j>=0;j--)
        if(depth[u]-(1<<j)>=depth[v])u=up[j][u];

    if(u==v)return u;

    for(int j=19;j>=0;j--)
        if(up[j][u]!=up[j][v])u=up[j][u],v=up[j][v];

    return up[0][u];
}

int t;
int in[nmax],out[nmax];

void dfs_sum(int node,int parent)
{
    sum[0][node]=(inp[node]!=inp[parent]);

    for(int i=1;i<20;i++)
    {
        sum[i][node]=sum[i-1][node]+sum[i-1][up[i-1][node]];
    }

    for(auto w:adj[node])
        if(w!=parent)
            dfs_sum(w,node);

    //cout<<node<<" -> ";for(int i=0;i<20;i++)cout<<sum[i][node]<<" ";cout<<endl;
}

void dfs(int node,int parent,int d)
{
    depth[node]=d;

    up[0][node]=parent;
    sum[0][node]=(inp[node]!=inp[parent]);

    for(int i=1;i<20;i++)
    {
        up[i][node]=up[i-1][up[i-1][node]];
    }

    t++;
    in[node]=t;

    for(auto w:adj[node])
        if(w!=parent)
            dfs(w,node,d+1);

    out[node]=t;
}

vector< pair<int/*node*/,int/*colour*/> > updates;

pair<int/*when*/,int/*colour*/> MX[nmax];

void dfs_colour(int node,int parent)
{
    MX[node]=max(MX[node],MX[parent]);

    for(auto w:adj[node])
        if(w!=parent)
        {
            dfs_colour(w,node);
        }
}

void apply()
{
    for(int i=1;i<=n;i++)
        MX[i]={-1,-1};

    for(int i=0;i<updates.size();i++)
        MX[updates[i].first]=max(MX[updates[i].first],make_pair(i,updates[i].second));

    dfs_colour(1,1);

    for(int i=1;i<=n;i++)
        if(MX[i].first>=0)inp[i]=MX[i].second;

   dfs_sum(1,1);
}

pair<int/*when*/,int/*colour*/> MX_u[nmax],MX_v[nmax];

int hand(int node,int h)
{
    //cout<<"hand "<<node<<" "<<h<<endl;

    int ret=0;

    for(int i=0;(1<<i)<=h;i++)
        if((h&(1<<i)))
        {
            //cout<<i<<" "<<node<<" -> "<<sum[i][node]<<endl;

            ret=ret+sum[i][node];
            node=up[i][node];

            h=h-(1<<i);
        }

    return ret;
}

bool is_parent(int u,int v)
{
    return in[u]<=in[v]&&out[v]<=out[u];
}

int query(int u,int v)
{
    if(u==v)return 0;

    if(in[u]>in[v])swap(u,v);

    int l=lca(u,v);

    vector< pair<int/*depth*/,int/*node*/> > nodes_u={},nodes_v={};

    nodes_u.push_back({depth[u],u});
    nodes_u.push_back({depth[l],l});

    nodes_v.push_back({depth[v],v});
    nodes_v.push_back({depth[l],l});

    for(int i=0;i<updates.size();i++)
    {
        int node=updates[i].first;

        if(is_parent(node,l))continue;

        if(is_parent(node,u))
        {
            nodes_u.push_back({depth[node],node});
            nodes_u.push_back({depth[node]-1,up[0][node]});
        }

        if(is_parent(node,v))
        {
            nodes_v.push_back({depth[node],node});
            nodes_v.push_back({depth[node]-1,up[0][node]});
        }
    }

    sort(nodes_u.begin(),nodes_u.end());
    sort(nodes_v.begin(),nodes_v.end());

    //cout<<"nodes_u: ";for(auto w:nodes_u)cout<<w.first<<" "<<w.second<<"\t";cout<<endl;
    //cout<<"nodes_v: ";for(auto w:nodes_v)cout<<w.first<<" "<<w.second<<"\t";cout<<endl;

    for(int i=0;i<nodes_u.size();i++)MX_u[i]={-1,-1};

    for(int i=0;i<nodes_v.size();i++)MX_v[i]={-1,-1};

    for(int i=0;i<updates.size();i++)
    {
        int node=updates[i].first;

        if(is_parent(node,l))
        {
            MX_u[0]={i,updates[i].second};
            MX_v[0]={i,updates[i].second};

            continue;
        }

        if(is_parent(node,u))
        {
            int pos=lower_bound(nodes_u.begin(),nodes_u.end(),make_pair(depth[node],0))-nodes_u.begin();

            MX_u[pos]=max(MX_u[pos],{i,updates[i].second});
        }

        if(is_parent(node,v))
        {
            int pos=lower_bound(nodes_v.begin(),nodes_v.end(),make_pair(depth[node],0))-nodes_v.begin();

            MX_v[pos]=max(MX_v[pos],{i,updates[i].second});
        }
    }

    int outp=0;

    for(int i=1;i<nodes_u.size();i++)
    {
        MX_u[i]=max(MX_u[i],MX_u[i-1]);

        if(nodes_u[i]!=nodes_u[i-1])
        {
            if(MX_u[i].first<0)outp=outp+hand(nodes_u[i].second,nodes_u[i].first-nodes_u[i-1].first);
            else
            {
                if(MX_u[i].first<0)
                {
                    if(inp[up[0][MX_u[i].second]]!=MX_u[i].second)outp++;
                }
                else
                {
                    if(MX_u[i].second!=MX_u[i-1].second)outp++;
                }
            }
        }
    }

    for(int i=1;i<nodes_v.size();i++)
    {
        MX_v[i]=max(MX_v[i],MX_v[i-1]);

        if(nodes_v[i]!=nodes_v[i-1])
        {
            if(MX_v[i].first<0)outp=outp+hand(nodes_v[i].second,nodes_v[i].first-nodes_v[i-1].first);
            else
            {
                if(MX_v[i].first<0)
                {
                    if(inp[up[0][MX_v[i].second]]!=MX_v[i].second)outp++;
                }
                else
                {
                    if(MX_v[i].second!=MX_v[i-1].second)outp++;
                }
            }
        }
    }

    return outp;
}

int main()
{
    scanf("%i",&n);

    for(int i=1;i<n;i++)
    {
        int u,v;
        scanf("%i%i",&u,&v);

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    dfs(1,1,0);

    dfs_sum(1,1);

    int q;
    scanf("%i",&q);

    int BLOCK=sqrt(q);

    for(int i=1;i<=q;i++)
    {
        if(i%BLOCK==0)apply();

        int type;
        scanf("%i",&type);

        if(type==1)
        {
            assert(0==1);
        }

        if(type==2)
        {
            int u,c;

            scanf("%i%i",&u,&c);

            updates.push_back({u,c});
        }

        if(type==3)
        {
            int u,v;

            scanf("%i%i",&u,&v);

            printf("%i\n",query(u,v));
        }
    }

    return 0;
}
/*
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
4
3 6 4
3 1 5
2 2 4
3 3 5
*/