#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

int n,inp[nmax];

vector<int> adj[nmax];

int depth[nmax];

int up[20][nmax];

int lca(int u,int v)
{
    if(depth[u]<depth[v])swap(u,v);

    for(int j=19;j>=0;j--)
        if(depth[u]-(1<<j)>=depth[v])u=up[j][u];

    if(u==v)return u;

    for(int j=19;j>=0;j--)
        if(up[j][u]!=up[j][v])u=up[j][u],v=up[j][v];

    return up[0][u];
}

int t;
int in[nmax],out[nmax];

int SZ[nmax];

void dfs(int node,int parent,int d)
{
    depth[node]=d;

    up[0][node]=parent;

    for(int i=1;i<20;i++)
    {
        up[i][node]=up[i-1][up[i-1][node]];
    }

    t++;
    in[node]=t;

    SZ[node]=1;

    for(auto w:adj[node])
        if(w!=parent)
        {
            dfs(w,node,d+1);
            SZ[node]+=SZ[w];
        }

    out[node]=t;
}

pair<int/*root*/,int/*where*/> group[nmax];

vector<int> ids[nmax];

struct info
{
    int sum;
    int lazy_diff;
    int lazy_colour;
};

vector<info> tree[nmax];

info actual(info a)
{
    if(a.lazy_diff==0)a.sum=0;

    a.lazy_colour=0;
    a.lazy_diff=-1;

    return a;
}

info my_merge(info a,info b)
{
    a=actual(a);
    b=actual(b);

    a.sum+=b.sum;
    return a;
}

void push(int id,int node)
{
    if(tree[id][node].lazy_colour)
    {
        tree[id][node*2].lazy_colour=tree[id][node].lazy_colour;
        tree[id][node*2+1].lazy_colour=tree[id][node].lazy_colour;
    }

    tree[id][node].lazy_colour=0;

    if(tree[id][node].lazy_diff==0)
    {
        tree[id][node*2].lazy_diff=0;
        tree[id][node*2+1].lazy_diff=0;
    }

    tree[id][node].lazy_diff=-1;
}

int colour(int id,int node,int l,int r,int pos)
{
    if(tree[id][node].lazy_colour>0)return tree[id][node].lazy_colour;

    push(id,node);

    int av=(l+r)/2;

    int ret=-1;

    if(pos<=av)ret=colour(id,node*2,l,av,pos);
    else ret=colour(id,node*2+1,av+1,r,pos);

    tree[id][node]=my_merge(tree[id][node*2],tree[id][node*2+1]);

    return ret;
}

int exact_colour(int node)
{
    int id=group[node].first;

    return colour(id,1,0,ids[id].size()-1,group[node].second);
}

int query(int id,int node,int l,int r,int lq,int rq)
{
    if(l==lq&&r==rq)
    {
        info help=actual(tree[id][node]);

        //cout<<"query "<<id<<" "<<node<<" "<<l<<" "<<r<<" -> "<<help.sum<<" "<<help.lazy_diff<<" "<<help.lazy_colour<<endl;

        return actual(tree[id][node]).sum;
    }

    push(id,node);

    int av=(l+r)/2;

    int ret=0;

    if(lq<=av)ret=ret+query(id,node*2,l,av,lq,min(av,rq));
    if(av<rq)ret=ret+query(id,node*2+1,av+1,r,max(av+1,lq),rq);

    tree[id][node]=my_merge(tree[id][node*2],tree[id][node*2+1]);

    return ret;
}

int ask(int id,int l,int r)
{
    //cout<<"ask "<<id<<" "<<l<<" "<<r<<" -> "<<query(id,0,0,ids[id].size()-1,l,r)<<endl;

    return query(id,1,0,ids[id].size()-1,l,r);
}

void update_group(int id,int node,int l,int r,int lq,int rq,int c)
{
    if(l==lq&&r==rq)
    {
        tree[id][node].lazy_colour=c;

        tree[id][node].sum=0;

        tree[id][node].lazy_diff=0;

        //cout<<"\t\tupdate group "<<id<<" "<<node<<" "<<l<<" "<<r<<endl;

        return;
    }

    push(id,node);

    int av=(l+r)/2;

    if(lq<=av)update_group(id,node*2,l,av,lq,min(av,rq),c);
    if(av<rq)update_group(id,node*2+1,av+1,r,max(av+1,lq),rq,c);

    tree[id][node]=my_merge(tree[id][node*2],tree[id][node*2+1]);
}

void update_hand(int id,int node,int l,int r,int pos,int c)
{
    if(l==r)
    {
        //cout<<"-----"<<endl;

        //cout<<"update_hand "<<id<<" "<<node<<" "<<l<<" "<<r<<" "<<pos<<" "<<c<<endl;

        if(c!=-1)
        {
            tree[id][node].lazy_colour=c;
        }

        if(pos)
        {
            //cout<<"\tuse "<<ids[id][pos]<<" and "<<ids[id][pos-1]<<" "<<exact_colour(ids[id][pos])<<" and "<<exact_colour(ids[id][pos-1])<<endl;

            tree[id][node].sum=(exact_colour(ids[id][pos])!=exact_colour(ids[id][pos-1]));
        }
        else tree[id][node].sum=0;

        tree[id][node].lazy_diff=-1;

        //cout<<"update_hand "<<id<<" "<<node<<" "<<l<<" "<<r<<" "<<pos<<" "<<c<<" -> "<<tree[id][node].sum<<endl;

        return;
    }

    push(id,node);

    int av=(l+r)/2;

    if(pos<=av)update_hand(id,node*2,l,av,pos,c);
    else update_hand(id,node*2+1,av+1,r,pos,c);

    tree[id][node]=my_merge(tree[id][node*2],tree[id][node*2+1]);

    //cout<<"updated hand "<<id<<" "<<node<<" "<<l<<" "<<r<<" "<<pos<<" -> "<<tree[id][node].sum<<" "<<tree[id][node].lazy_colour<<" "<<tree[id][node].lazy_diff<<endl;
}

void to_update(int id,int l,int r,int c)
{
    //cout<<"to_update "<<id<<" "<<l<<" "<<r<<" "<<c<<endl;

    if(l!=r)update_group(id,1,0,ids[id].size()-1,l+1,r,c);

    update_hand(id,1,0,ids[id].size()-1,l,c);

    if(r!=ids[id].size()-1)update_hand(id,1,0,ids[id].size()-1,r+1,-1);

    /*
    cout<<"after updates"<<endl;

    for(auto w:ids[id])cout<<exact_colour(w)<<" ";cout<<endl;

    for(int i=0;i<ids[id].size();i++)
        for(int j=i;j<ids[id].size();j++)
            cout<<i<<" "<<j<<" -> "<<query(id,1,0,ids[id].size()-1,i,j)<<endl;

    cout<<"---"<<endl;
    */
}

void update_path(int u,int real_l,int c)
{
    while(group[u].first!=group[real_l].first)
    {
        to_update(group[u].first,0,group[u].second,c);

        u=group[u].first;

        u=ids[u][0];

        u=up[0][u];
    }

    to_update(group[u].first,group[real_l].second,group[u].second,c);
}

void build(int id,int node,int l,int r)
{
    if(l==r)
    {
        tree[id][node].lazy_colour=inp[ids[id][l]];
        tree[id][node].lazy_diff=-1;

        if(l)tree[id][node].sum=(inp[ids[id][l]]!=inp[ids[id][l-1]]);

        //cout<<id<<" "<<node<<" "<<l<<" -> "<<tree[id][node].sum<<endl;

        return;
    }

    int av=(l+r)/2;

    build(id,node*2,l,av);
    build(id,node*2+1,av+1,r);

    tree[id][node]=my_merge(tree[id][node*2],tree[id][node*2+1]);
}

void dfs_hld(int node,int parent,int g)
{
    group[node]={g,ids[g].size()};

    ids[g].push_back(node);

    int big=-1;

    for(auto w:adj[node])
        if(w!=parent)
        {
            if(big==-1)big=w;
            else if(SZ[big]<SZ[w])big=w;
        }

    if(big==-1)return;

    dfs_hld(big,node,g);

    for(auto w:adj[node])
        if(w!=parent&&w!=big)
            dfs_hld(w,node,w);
}

/*
void dfs_slow(int node,int parent,int c)
{
    update_path(node,node,c);

    for(auto w:adj[node])
        if(w!=parent)
            dfs_slow(w,node,c);
}
*/

int on_path(int u,int l)
{
    if(u==l)return 0;

    //cout<<u<<" "<<l<<" -> ";

    //l is invalid

    int outp=0;

    while(group[u].first!=group[l].first)
    {
        //cout<<u<<" "<<real_l<<endl;

        outp=outp+ask(group[u].first,0,group[u].second);

        //cout<<"343 "<<endl;

        u=group[u].first;

        u=ids[u][0];

        //cout<<"347"<<endl;

        //cout<<"on_path "<<u<<" "<<up[0][u]<<" "<<exact_colour(u)<<" "<<exact_colour(up[0][u])<<endl;

        if(exact_colour(u)!=exact_colour(up[0][u]))outp++;

        //cout<<"u= "<<u<<" "<<outp<<endl;

        //cout<<"353"<<endl;

        u=up[0][u];
    }

    //cout<<"358"<<endl;

    if(group[l].second!=group[u].second)outp=outp+ask(group[u].first,group[l].second+1,group[u].second);

    //cout<<outp<<endl;

    return outp;
}

void upd(int u,int v,int c)
{
    int l=lca(u,v);

    update_path(u,l,c);
    update_path(v,l,c);
}

int query(int u,int v)
{
    int l=lca(u,v);

    return on_path(u,l)+on_path(v,l);
}

mt19937 rng(42);

int slow(int u,int v)
{
    int outp=0;

    while(u!=v)
    {
        if(depth[u]<depth[v])
        {
            if(inp[v]!=inp[up[0][v]])outp++;

            v=up[0][v];
        }
        else
        {
            if(inp[u]!=inp[up[0][u]])outp++;

            u=up[0][u];
        }

        //cout<<u<<" "<<v<<" "<<outp<<endl;
    }

    return outp;
}

int main()
{
    scanf("%i",&n);

    //n=1000;

    for(int i=1;i<n;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);

        /*
        v=i+1;
        u=rng()%i+1;

        cout<<u<<" "<<v<<endl;
        */

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);
    /*
    {
        inp[i]=rng()%n+1;
        cout<<inp[i]<<" ";
    }
    cout<<endl;
    */

    dfs(1,1,0);

    dfs_hld(1,1,1);

    for(int i=1;i<=n;i++)
        if(ids[i].size())
        {
            //cout<<i<<" -> ";for(auto w:ids[i])cout<<w<<" ";cout<<endl;

            for(int j=0;j<=4*ids[i].size();j++)
            {
                info cur;
                cur.sum=0;
                cur.lazy_colour=0;
                cur.lazy_diff=-1;

                tree[i].push_back(cur);
            }

            build(i,1,0,ids[i].size()-1);

            /*
            cout<<"after updates"<<endl;
            for(int p=0;p<ids[i].size();p++)
                for(int j=p;j<ids[i].size();j++)
                    cout<<p<<" "<<j<<" -> "<<query(i,1,0,ids[i].size()-1,p,j)<<endl;

            cout<<"---"<<endl;
            */
        }

    int q;
    scanf("%i",&q);

    vector<pair<int/*in*/,int/*node*/> > roots={};

    for(int i=1;i<=n;i++)
        if(group[i].first==i)roots.push_back({in[i],i});

    sort(roots.begin(),roots.end());

    for(int i=1;i<=q;i++)
    {
        //cout<<"exact: ";for(int j=1;j<=n;j++)cout<<exact_colour(j)<<" ";cout<<endl;

        int type;
        scanf("%i",&type);

        if(type==1)
        {
            int u,v,c;

            scanf("%i%i%i",&u,&v,&c);

            upd(u,v,c);
        }

        if(type==2)
        {
            int u,c;

            scanf("%i%i",&u,&c);

            update_path(ids[group[u].first].back(),u,c);

            int from=lower_bound(roots.begin(),roots.end(),make_pair(in[u],0))-roots.begin();
            int to=upper_bound(roots.begin(),roots.end(),make_pair(out[u],n+1))-roots.begin();

            to--;

            for(int j=from;j<=to;j++)
                update_path(ids[roots[j].second].back(),ids[roots[j].second][0],c);
        }

        if(type==3)
        {
            int u,v;

            scanf("%i%i",&u,&v);

            printf("%i\n",query(u,v));
        }
    }

    return 0;
}
