#include <bits/stdc++.h>
using namespace std;

const int maxn = 100005;
int n, q;
vector <int> adj [maxn];
int col [maxn];
int par [maxn], subtreeSz [maxn];
vector <int> hldOrder;
int hldPos [maxn], chainStart [maxn];
vector <int> eulerTour;
int eulerTourPos [maxn];
int depth [maxn];

void dfs1 (int a){
    eulerTourPos [a] = eulerTour.size ();
    eulerTour.push_back (a);
    subtreeSz [a] = 1;
    for (int i : adj [a]){
        if (i != par [a]){
            par [i] = a;
            depth [i] = depth [a] + 1;
            dfs1 (i);
            eulerTour.push_back (a);
            subtreeSz [a] += subtreeSz [i];
        }
    }
}

void dfs2 (int a){
    if (a == 0) return;
    hldPos [a] = hldOrder.size ();
    hldOrder.push_back (a);
    int maxChild = 0;
    for (int i : adj [a]){
        if (i != par [a] && subtreeSz [i] > subtreeSz [maxChild]) maxChild = i;
    }
    chainStart [maxChild] = chainStart [a];
    dfs2 (maxChild);
    for (int i : adj [a]){
        if (i != par [a] && i != maxChild){
            chainStart [i] = i;
            dfs2 (i);
        }
    }
}

pair <int, int> treeEulerTour [8 * maxn];
void buildEulerTour (int l, int r, int pos){
    if (l == r){
        treeEulerTour [pos] = {depth [eulerTour [l]], eulerTour [l]};
        return;
    }
    int mid = l + r >> 1;
    buildEulerTour (l, mid, pos << 1);
    buildEulerTour (mid + 1, r, pos << 1 | 1);
    treeEulerTour [pos] = min (treeEulerTour [pos << 1], treeEulerTour [pos << 1 | 1]);
}
pair <int, int> queryEulerTour (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return treeEulerTour [pos];
    if (l > qr || r < ql) return {n, n};
    int mid = l + r >> 1;
    return min (queryEulerTour (l, mid, pos << 1, ql, qr), queryEulerTour (mid + 1, r, pos << 1 | 1, ql, qr));
}
int findLCA (int a, int b){
    int x = eulerTourPos [a], y = eulerTourPos [b];
    if (x > y) swap (x, y);
    auto q = queryEulerTour (0, eulerTour.size () - 1, 1, x, y);
    return q.second;
}

int treeHld [maxn * 4];
bool lazyHld [maxn * 4];
int lazyColor [maxn * 4];
void buildHld (int l, int r, int pos){
    if (l == r){
        if (col [hldOrder [l]] != col [hldOrder [l + 1]]) treeHld [pos] = 1;
        return;
    }
    int mid = l + r >> 1;
    buildHld (l, mid, pos << 1);
    buildHld (mid + 1, r, pos << 1 | 1);
    treeHld [pos] = treeHld [pos << 1] + treeHld [pos << 1 | 1];
}
void updLazyHld (int l, int r, int pos){
    if (lazyHld [pos]){
        treeHld [pos] = 0;
        if (l != r){
            lazyHld [pos << 1] = 1;
            lazyHld [pos << 1 | 1] = 1;
        }
        lazyHld [pos] = 0;
    }
}
void updHld1 (int l, int r, int pos, int x, int val){
    updLazyHld (l, r, pos);
    if (l == r){
        treeHld [pos] = val;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) updHld1 (l, mid, pos << 1, x, val);
    else updHld1 (mid + 1, r, pos << 1 | 1, x, val);
    treeHld [pos] = treeHld [pos << 1] + treeHld [pos << 1 | 1];
}
void updHld2 (int l, int r, int pos, int ql, int qr){
    updLazyHld (l, r, pos);
    if (l >= ql && r <= qr){
        lazyHld [pos] = 1;
        updLazyHld (l, r, pos);
        return;
    }
    if (l > qr || r < ql) return;
    int mid = l + r >> 1;
    updHld2 (l, mid, pos << 1, ql, qr);
    updHld2 (mid + 1, r, pos << 1 | 1, ql, qr);
    treeHld [pos] = treeHld [pos << 1] + treeHld [pos << 1 | 1];
}
int queryHld (int l, int r, int pos, int ql, int qr){
    updLazyHld (l, r, pos);
    if (l >= ql && r <= qr) return treeHld [pos];
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return queryHld (l, mid, pos << 1, ql, qr) + queryHld (mid + 1, r, pos << 1 | 1, ql, qr);
}
void updLazyColor (int l, int r, int pos){
    if (lazyColor [pos] && l != r){
        lazyColor [pos << 1] = lazyColor [pos];
        lazyColor [pos << 1 | 1] = lazyColor [pos];
        lazyColor [pos] = 0;
    }
}
void updColor (int l, int r, int pos, int c, int ql, int qr){
    updLazyColor (l, r, pos);
    if (l >= ql && r <= qr){
        lazyColor [pos] = c;
        updLazyColor (l, r, pos);
        return;
    }
    if (l > qr || r < ql) return;
    int mid = l + r >> 1;
    updColor (l, mid, pos << 1, c, ql, qr);
    updColor (mid + 1, r, pos << 1 | 1, c, ql, qr);
}
int queryColor (int l, int r, int pos, int x){
    updLazyColor (l, r, pos);
    if (l == r){
        if (!lazyColor [pos]){
            if (l >= hldOrder.size ()) return 0;
            return col [hldOrder [l]];
        }
        else return lazyColor [pos];
    }
    int mid = l + r >> 1;
    if (x <= mid) return queryColor (l, mid, pos << 1, x);
    else return queryColor (mid + 1, r, pos << 1 | 1, x);
}

void updPath (int a, int top, int c){
    int b = chainStart [a];
    if (depth [b] < depth [top]) b = top;
    int u = hldPos [b], v = hldPos [a];
    int prevAColor = queryColor (0, n - 1, 1, v);
    int prevBColor = queryColor (0, n - 1, 1, u);
    updColor (0, n - 1, 1, c, u, v);
    updHld2 (0, n - 1, 1, u, v - 1);
    int childColor = queryColor (0, n - 1, 1, v + 1);
    if (childColor == prevAColor && childColor != c) updHld1 (0, n - 1, 1, v, 1);
    else if (childColor != prevAColor && childColor == c) updHld1 (0, n - 1, 1, v, 0);
    if (b != chainStart [a]){
        int parColor = queryColor (0, n - 1, 1, u - 1);
        if (parColor == prevBColor && parColor != c) updHld1 (0, n - 1, 1, u - 1, 1);
        else if (parColor != prevBColor && parColor == c) updHld1 (0, n - 1, 1, u - 1, 0);
    }
    if (b != top) updPath (par [b], top, c);
}
int queryPath (int a, int top){
    int b = chainStart [a];
    if (depth [b] < depth [top]) b = top;
    int u = hldPos [b], v = hldPos [a];
    int q = queryHld (0, n - 1, 1, u, v - 1);
    if (b != top){
        int nxt = par [b], uNxt = hldPos [nxt];
        int c1 = queryColor (0, n - 1, 1, u), c2 = queryColor (0, n - 1, 1, uNxt);
        if (c1 != c2) q ++;
        q += queryPath (nxt, top);
    }
    return q;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 1; i < n; i ++){
        int a, b;
        cin >> a >> b;
        adj [a].push_back (b);
        adj [b].push_back (a);
    }
    for (int i = 1; i <= n; i ++){
        cin >> col [i];
    }
    dfs1 (1);
    buildEulerTour (0, eulerTour.size () - 1, 1);
    chainStart [1] = 1;
    dfs2 (1);
    buildHld (0, n - 1, 1);
    cin >> q;
    while (q --){
        int type;
        cin >> type;
        if (type == 1){
            int u, v, c;
            cin >> u >> v >> c;
            int lca = findLCA (u, v);
            updPath (u, lca, c);
            updPath (v, lca, c);
        }
        else{
            int u, v;
            cin >> u >> v;
            int lca = findLCA (u, v);
            cout << queryPath (u, lca) + queryPath (v, lca) << '\n';
        }
    }

}

/*

6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
1
3 1 3

*/
