#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 1e5 + 3;
const int maxlog = 19;

struct node {
    int first, last, changes, lazy;
    node() {lazy = -1;}
};

node tr[maxn * 4];
int n, q;
int c[maxn];
vector <int> adj[maxn];

void push(int v, int l, int r) {
    if (tr[v].lazy != -1) {
        tr[v].first = tr[v].last = tr[v].lazy;
        tr[v].changes = 0;
        if (l != r)
            tr[v * 2].lazy = tr[v * 2 + 1].lazy = tr[v].lazy;

        tr[v].lazy = -1;
    }
}

void merge(int v) {
    tr[v].first = tr[v * 2].first;
    tr[v].last = tr[v * 2 + 1].last;
    tr[v].changes = tr[v * 2].changes + tr[v * 2 + 1].changes;
    if (tr[v * 2].last != tr[v * 2 + 1].first)
        tr[v].changes++;
}

vector <int> order;
void build(int v, int l, int r) {
    if (l == r) {
        tr[v].first = tr[v].last = c[order[l-1]];
        tr[v].changes = 0;
        return;
    }

    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);

    merge(v);
}

int last, ans, tmp;
void get(int v, int l, int r, int ll, int rr) {
    push(v, l, r);
    if (l > rr || r < ll)
        return;

    if (l >= ll && r <= rr) {
        ans += tr[v].changes;
        if (tr[v].first != last && last != -1)
            ans++;

        last = tr[v].last;
        if (tmp == -1)
            tmp = tr[v].first;

        return;
    }

    int mid = (l + r) / 2;
    get(v * 2, l, mid, ll, rr);
    get(v * 2 + 1, mid + 1, r, ll, rr);
}

void update(int v, int l, int r, int ll, int rr, int c) {
    push(v, l, r);
    if (l > rr || r < ll)
        return;

    if (l >= ll && r <= rr) {
        tr[v].lazy = c;
        push(v, l, r);
        return;
    }

    int mid = (l + r) / 2;
    update(v * 2, l, mid, ll, rr, c);
    update(v * 2 + 1, mid + 1, r, ll, rr, c);

    merge(v);
}


int pos[maxn], sz[maxn];
int head[maxn];
int par[maxn][maxlog];

void pre_dfs(int ver) {
    sz[ver] = 1;
    for (auto i: adj[ver])
    if (i != par[ver][0]) {
        par[i][0] = ver;
        pre_dfs(i);

        sz[ver] += sz[i];
    }
}

void dfs(int ver, int curr_head) {
    order.push_back(ver);
    pos[ver] = (int)order.size();
    head[ver] = curr_head;

    int max_sz = -1, idx = -1;
    for (auto i: adj[ver])
    if (i != par[ver][0] && sz[i] > max_sz) {
        max_sz = sz[i];
        idx = i;
    }

    if (idx == -1)
        return;

    dfs(idx, curr_head);
    for (auto i: adj[ver])
        if (i != par[ver][0] && i != idx)
        dfs(i, i);
}

bool is_inside(int a, int b) {
    return pos[a] <= pos[b] && pos[a] + sz[a] - 1 >= pos[b];
}

void precompute() {
    par[1][0] = -1;
    pre_dfs(1);
    dfs(1, 1);

    for (int j = 1; j < maxlog; j++)
    for (int i = 1; i <= n; i++) {
        par[i][j] = par[i][j-1];
        if (par[i][j] == -1)
            continue;

        par[i][j] = par[par[i][j]][j-1];
    }
}

int lca(int a, int b) {
    if (is_inside(a, b))
        return a;

    if (is_inside(b, a))
        return b;

    for (int i = maxlog-1; i >= 0; i--)
        if (par[a][i] != -1 && !is_inside(par[a][i], b))
        a = par[a][i];

    return par[a][0];
}

void read() {
    cin >> n;
    for (int i = 1; i <= n-1; i++) {
        int a, b;
        cin >> a >> b;

        adj[a].push_back(b);
        adj[b].push_back(a);
    }

    for (int i = 1; i <= n; i++)
        cin >> c[i];

    cin >> q;
}

struct segment {
    int l, r;
    bool last;

    segment() {}
    segment(int l, int r, bool last) {
        this->l = l;
        this->r = r;
        this->last = last;
    }
};

vector <segment> get_path(int a, int b) {
    int c = lca(a, b);

    vector <segment> ans1, ans2;
    while (pos[head[a]] > pos[c]) {
        ans1.push_back(segment(pos[head[a]], pos[a], true));
        a = par[head[a]][0];
    }
    ans1.push_back(segment(pos[c], pos[a], true));

    while (pos[head[b]] > pos[c]) {
        ans2.push_back(segment(pos[head[b]], pos[b], false));
        b = par[head[b]][0];
    }

    if (pos[c] + 1 <= pos[b])
    ans2.push_back(segment(pos[c] + 1, pos[b], false));
    reverse(ans2.begin(), ans2.end());

    for (auto i: ans2)
        ans1.push_back(i);

    return ans1;
}

void solve() {
    precompute();
    build(1, 1, n);

    while (q--) {
        int type;
        cin >> type;

        if (type == 1) {
            int a, b, color;
            cin >> a >> b >> color;

            auto temp = get_path(a, b);
            for (auto i: temp)
                update(1, 1, n, i.l, i.r, color);
        }

        else if (type == 2) {
            int ver, color;
            cin >> ver >> color;

            update(1, 1, n, pos[ver], pos[ver] + sz[ver] - 1, color);
        }

        else {
            int a, b;
            cin >> a >> b;
            auto temp = get_path(a, b);
           // for (auto i: temp)
               // cout << i.l << " " << i.r << " " << i.last << endl;

            last = -1, ans = 0;
            for (auto i: temp) {
                tmp = -1;
                get(1, 1, n, i.l, i.r);

                if (i.last)
                last = tmp;

               // cout << last << "wtf" << endl;
            }

            cout << ans << endl;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
