#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int mod = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= mod)
        a -= mod;

    return a;
}

int l;
struct matrix {
    vector <vector <int> > m;
    matrix() {
        m.resize(l * l);
        for (int i = 0; i < l * l; i++)
            m[i].resize(l * l, 0);
    }

    matrix operator * (const matrix &other) {
        matrix ans;
        for (int i = 0; i < l * l; i++)
            for (int j = 0; j < l * l; j++)
            for (int k = 0; k < l * l; k++)
            ans.m[i][j] = add(ans.m[i][j], (long long)m[i][k] * other.m[k][j] % mod);

        return ans;
    }
};

string str;
int n, m;
pair <pair <char, char>, char> rule[130];
void read() {
    cin >> str >> n >> m;
    for (int i = 1; i <= m; i++) {
        cin >> rule[i].first.first >> rule[i].first.second >> rule[i].second;
    }
}

int get_idx(int f, int s) {
    return f * l + s;
}

matrix fast_pow(matrix a, int deg) {
    matrix ans = a, y = a;
    deg--;
    while (deg) {
        if (deg & 1)
        ans = ans * y;

        y = y * y;
        deg >>= 1;
    }

    return ans;
}

int fast_pow_num(int x, int deg) {
    int ans = 1, y = x;
    while (deg) {
        if (deg & 1)
            ans = (long long)ans * y % mod;

        deg >>= 1;
        y = (long long)y * y % mod;
    }

    return ans;
}

int cnt[26 * 26];
int ans[26];
void solve() {
    vector <char> vec;
    for (auto i: str)
        vec.push_back(i);

    for (int i = 1; i <= m; i++) {
        vec.push_back(rule[i].first.first);
        vec.push_back(rule[i].first.second);
        vec.push_back(rule[i].second);
    }

    sort (vec.begin(), vec.end());
    vec.erase(unique(vec.begin(), vec.end()), vec.end());

    l = vec.size();
    matrix transition;
    for (int i = 0; i < l * l; i++)
    transition.m[i][i] = 1;

    for (int i = 1; i <= m; i++) {
        int f = lower_bound(vec.begin(), vec.end(), rule[i].first.first) - vec.begin();
        int s = lower_bound(vec.begin(), vec.end(), rule[i].first.second) - vec.begin();
        int t = lower_bound(vec.begin(), vec.end(), rule[i].second) - vec.begin();

        transition.m[get_idx(f, t)][get_idx(f, s)]++;
        transition.m[get_idx(t, s)][get_idx(f, s)]++;
        transition.m[get_idx(f, s)][get_idx(f, s)]--;
    }

    matrix initial;
    for (int i = 0; i < (int)str.size()-1; i++) {
        int f = lower_bound(vec.begin(), vec.end(), str[i]) - vec.begin();
        int s = lower_bound(vec.begin(), vec.end(), str[i+1]) - vec.begin();

        cnt[get_idx(f, s)]++;
    }

    transition = fast_pow(transition, n);
    for (int i = 0; i < l * l; i++) {
        int sum = 0;
        for (int j = 0; j < l * l; j++)
            sum = add(sum, (long long)cnt[j] * transition.m[i][j] % mod);

        ans[vec[i/l]-'A'] = add(ans[vec[i/l]-'A'], sum);
        ans[vec[i%l]-'A'] = add(ans[vec[i%l]-'A'], sum);
    }

    ans[str[0]-'A'] = add(ans[str[0]-'A'], 1);
    ans[str[(int)str.size()-1]-'A'] = add(ans[str[(int)str.size()-1]-'A'], 1);
    for (int i = 0; i < 26; i++) {
        ans[i] = (long long)ans[i] * fast_pow_num(2, mod-2) % mod;
        cout << (char)(i + 'A') << " " << ans[i] << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
