#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int mod = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= mod)
        a -= mod;

    return a;
}

int al;
struct matrix {
    vector <vector <int> > m;
    matrix() {
        m.resize(al);
        for (int i = 0; i < al; i++)
            m[i].resize(al, 0);
    }

    matrix operator * (const matrix &other) {
        matrix ans;
        for (int i = 0; i < al; i++)
            for (int j = 0; j < al; j++)
            for (int k = 0; k < al; k++)
            ans.m[i][j] = add(ans.m[i][j], (long long)m[i][k] * other.m[k][j] % mod);

        return ans;
    }
};

string str;
int n, m;
pair <pair <int, int>, int> rule[130];
void read() {
    cin >> str >> n >> m;
    for (int i = 1; i <= m; i++) {
        char f, s, t;
        cin >> f >> s >> t;

        rule[i].first.first = f - 'A';
        rule[i].first.second = s - 'A';
        rule[i].second = t - 'A';
    }
}

int get_idx(int f, int s) {
    return f * 26 + s;
}

matrix fast_pow(matrix a, int deg) {
    matrix ans = a, y = a;
    deg--;
    while (deg) {
        if (deg & 1)
        ans = ans * y;

        y = y * y;
        deg >>= 1;
    }

    return ans;
}

int fast_pow_num(int x, int deg) {
    int ans = 1, y = x;
    while (deg) {
        if (deg & 1)
            ans = (long long)ans * y % mod;

        deg >>= 1;
        y = (long long)y * y % mod;
    }

    return ans;
}

int find_pos(vector <int> &v, int x) {
    int pos = lower_bound(v.begin(), v.end(), x) - v.begin();
    if (pos < (int)v.size() && v[pos] == x)
        return pos;

    return -1;
}

int cnt[26 * 26];
int ans[26];
int func[26 * 26];
bool is[26][26];
void solve() {
    vector <int> all;
    for (int i = 1; i <= m; i++) {
        int f = rule[i].first.first;
        int s = rule[i].first.second;
        int t = rule[i].second;

        all.push_back(get_idx(f, s));
    }

    sort (all.begin(), all.end());
    all.erase(unique(all.begin(), all.end()), all.end());

    al = (int)all.size() * 2;
    matrix transition;
    for (int i = 0; i < al; i++)
    transition.m[i][i]++;

    for (int i = 1; i <= m; i++) {
        int f = rule[i].first.first;
        int s = rule[i].first.second;
        int t = rule[i].second;

        is[f][s] = true;

        int f1 = get_idx(f, s), f2 = get_idx(f, t), f3 = get_idx(t, s);
        f1 = find_pos(all, f1);
        f2 = find_pos(all, f2);
        f3 = find_pos(all, f3);

        if (f2 != -1) {
            transition.m[f2][f1]++;
            transition.m[f2+al/2][f1]++;
        }

        if (f3 != -1) {
            transition.m[f3][f1]++;
            transition.m[f3+al/2][f1]++;
        }

        transition.m[f1][f1]--;
    }

    for (int i = 0; i < (int)str.size()-1; i++) {
        int curr = find_pos(all, get_idx(str[i]-'A', str[i+1]-'A'));
        if (curr == -1)
            continue;

        cnt[curr]++;
        cnt[curr+al/2]++;
    }

    transition = fast_pow(transition, n);
    for (int i = 0; i < al; i++) {
        int sum = 0;
        for (int j = 0; j < al; j++)
            sum = add(sum, (long long)cnt[j] * transition.m[i][j] % mod);

        func[i] = sum;
    }

    for (int i = 0; i < al / 2; i++) {
        ans[all[i]/26] = add(ans[all[i]/26], func[i]);
        ans[all[i]%26] = add(ans[all[i]%26], func[i]);
    }

    //for (int i = al / 2; i < al; i++) {
    //    cout << (char)('A' + all[i - al / 2] / 26) << " " << (char)('A' + all[i - al / 2] % 26) << " " << func[i] << endl;
   // }

    for (int i = 1; i <= m; i++) {
        int f = rule[i].first.first;
        int s = rule[i].first.second;
        int t = rule[i].second;

        int f1 = get_idx(f, s), f2 = get_idx(f, t), f3 = get_idx(t, s);
        f1 = find_pos(all, f1);
        f2 = find_pos(all, f2);
        f3 = find_pos(all, f3);

        if (f2 == -1) {
            ans[f] = add(ans[f], (func[f1+al/2] - func[f1] + mod) % mod);
            ans[t] = add(ans[t], (func[f1+al/2] - func[f1] + mod) % mod);
        }

        if (f3 == -1) {
            ans[t] = add(ans[t], (func[f1+al/2] - func[f1] + mod) % mod);
            ans[s] = add(ans[s], (func[f1+al/2] - func[f1] + mod) % mod);
        }
    }

    for (int i = 0; i < (int)str.size()-1; i++)
    if (!is[str[i]-'A'][str[i+1]-'A']) {
        ans[str[i]-'A'] = add(ans[str[i]-'A'], 1);
        ans[str[i+1]-'A'] = add(ans[str[i+1]-'A'], 1);
    }

    ans[str[0]-'A'] = add(ans[str[0]-'A'], 1);
    ans[str[(int)str.size()-1]-'A'] = add(ans[str[(int)str.size()-1]-'A'], 1);
    for (int i = 0; i < 26; i++) {
        ans[i] = (long long)ans[i] * fast_pow_num(2, mod-2) % mod;
        cout << (char)(i + 'A') << " " << ans[i] << endl;
    }


}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
