#include <iostream>
#include <unordered_map>
#include <string>

using namespace std;

unordered_map <string, char> rules;

const int maxL = 30;
long long countMonomer[maxL];  ///countMonomer[0] = number of 'A'-s, ..., countMonomer[25] = number of 'Z'-s
const int MOD = 1000000007;

void func (char a, char b, int n){

    string s = {a, b};

    char next = rules[s];
    countMonomer[next - 'A']++;

    if(n == 1) return;

    func(a, next, n-1);
    func(next, b, n-1);

    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    string initialPolymer;
    cin >> initialPolymer;

    int N, M;
    cin >> N >> M;

    for(int i = 0; i < M; i ++){
        char a, b, c;
        cin >> a >> b >> c;

        string s = {a, b};
        rules.insert({s, c});
    }

    char curr, last;
    last = initialPolymer[0];
    countMonomer[last - 'A']++;

    for(int i = 1; i < initialPolymer.size(); i++){
        curr = initialPolymer[i];
        countMonomer[curr - 'A']++;

        func(last, curr, N);

        last = curr;
    }

    curr = 'A';
    for(int i = 0 ; i < 26; i++){
        cout << curr << " " << countMonomer[i] << endl;
        curr++;
    }

    return 0;
}
