#include <iostream>
#include <string>
#include <unordered_map>

using namespace std;

char rules[3000];       /// "XY" := ('X' - 'A')*100 + ('Y' - 'A')
                        /// "XY -> Z"  =>  rules["XY"] = 'Z'
int beginnings[3000];  ///two subsequent characters from initialPolymer

const int maxL = 30;
long long countMonomer[maxL][2];  ///countMonomer[0] = number of 'A'-s, ..., countMonomer[25] = number of 'Z'-s
const int MOD = 1000000007;

char decode[30];

void func (char a, char b, int n){

    int code = (a - 'A')*100 + (b - 'A');

    char next = rules[code];
    countMonomer[next - 'A'][1]++;
    if(countMonomer[next - 'A'][1] >= MOD) countMonomer[next - 'A'][1] %= MOD;

    if(n == 1) return;

    func(a, next, n-1);
    func(next, b, n-1);

    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    char curr = 'A';
    for(int i = 0; i < 26; i++){
        decode[i] = curr;
        curr++;
    }

    string initialPolymer;
    cin >> initialPolymer;

    int N, M;
    cin >> N >> M;

    for(int i = 0; i < M; i++){
        char a, b, c;
        cin >> a >> b >> c;

        int code = (a - 'A')*100 + (b - 'A');
        rules[code] = c;
    }

    char last = initialPolymer[0];
    countMonomer[last - 'A'][0]++;
    if(countMonomer[last - 'A'][0] >= MOD) countMonomer[last - 'A'][0] %= MOD;

    for(int i = 1; i < initialPolymer.size(); i++){
        curr = initialPolymer[i];
        countMonomer[curr - 'A'][0]++;
        if(countMonomer[curr - 'A'][0] >= MOD) countMonomer[curr - 'A'][0] %= MOD;

        int code = (last - 'A')*100 + (curr - 'A');
        beginnings[code]++;

        last = curr;
    }

    for(int i = 0; i < 3000; i++){
        if(beginnings[i] == 0) continue;

        char first = decode[i/100];
        char second = decode[i%100];
        func(first, second, N);

        for(int j = 0; j < 26; j++){
            countMonomer[j][0] += countMonomer[j][1] * beginnings[i];
            if(countMonomer[j][0] >= MOD) countMonomer[j][0] %= MOD;
            countMonomer[j][1] = 0;
        }
    }

    curr = 'A';
    for(int i = 0; i < 26; i++){
        cout << curr << " " << countMonomer[i][0] << endl;
        curr++;
    }

    return 0;
}

/*

NNCBNNC
4 16
CH B
HH N
CB H
NH C
HB C
HC B
HN C
NN C
BH H
NC B
NB B
BN B
BB N
BC B
CC N
CN C

*/
