#include <bits/stdc++.h>
using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

#define endl "\n"
#define out(x) "[" << #x << "=" << x << "]"

template<class T, class T2>
ostream& operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T>
ostream& operator <<(ostream &out, const vector<T> &x) {
    for(const auto &it : x) {
        out << it << " ";
    }
    return out;
}

struct debug {
    debug() { cerr << "->"; }
    ~debug() { cerr << endl; }

    template<class T>
    debug &operator <<(const T &x) {
        cerr << x << " ";
        return *this;
    }
};
#define dbg debug()

template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
///~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_N = 1e5 + 10;

struct Node {
    ll st, en, sum, lazy;

    Node(ll x = -1) {
        st = en = lazy = x;
        sum = 0;
    }
};

Node operator +(const Node &a, const Node &b) {
    Node ret;
    if(a.st == -1) { return b; }
    if(b.st == -1) { return a; }
    ret.st = a.st;
    ret.en = b.en;
    ret.sum = a.sum + b.sum + (int)(a.en != b.st);
    return ret;
}

ostream &operator <<(ostream &out, const Node &a) {
    return out << a.st << " " << a.en << " " << a.sum;
}

Node reverse(const Node &a) {
    Node ret;
    ret.en = a.st;
    ret.st = a.en;
    ret.sum = a.sum;
    return ret;
}

struct SegTree {
    Node tree[4 * MAX_N];

    void upd(int curr, int l, int r, int ql, int qr, int val) {
        apply(curr, l, r);
        if(ql <= l && r <= qr) {
            tree[curr].lazy = val;
            apply(curr, l, r);
            return;
        } else if(ql > r || qr < l) {return;}
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ql, qr, val);
        upd(curr * 2 + 1, m + 1, r, ql, qr, val);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }

    Node sum(int curr, int l, int r, int ql, int qr) {
        apply(curr, l, r);
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(ql > r || qr < l) {
            return Node();
        }
        int m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }

    void apply(int curr, int l, int r) {
        if(tree[curr].lazy == -1) {return;}
        int lazy = tree[curr].lazy;
        tree[curr] = Node(lazy);

        if(l != r) {
            tree[curr * 2].lazy = lazy;
            tree[curr * 2 + 1].lazy = lazy;
        }
    }
};

vector<int> g[MAX_N];
int n, q;
int arr[MAX_N];

int par[MAX_N], d[MAX_N], sz[MAX_N], big[MAX_N];

void dfs(int x, int p) {
    sz[x] = 1;
    big[x] = -1;
    d[x] = d[p] + 1;
    par[x] = p;

    for(auto it : g[x]) {
        if(it == p) { continue; }

        dfs(it, x);
        sz[x] += sz[it];

        if(big[x] == -1 || sz[it] > sz[big[x]]) {
            big[x] = it;
        }
    }
}

int in[MAX_N], out[MAX_N], tme = 0;
int head[MAX_N], start[MAX_N], place[MAX_N];

void eul(int x, int p, int who, int pos) {
    int now = tme ++;
    in[x] = now;

    head[x] = who;
    place[x] = pos;

    if(big[x] != -1) {
        eul(big[x], x, who, pos + 1);
    }

    for(auto it : g[x]) {
        if(it == p || it == big[x]) {continue;}
        eul(it, x, it, 0);
    }

    out[x] = tme - 1;
}

SegTree st;

Node getNow(ll x) {
    return st.sum(1, 0, MAX_N - 1, in[x], in[x]);
}

ll path(int a, int b) {
    Node lft, rght;

    while(head[a] != head[b]) {
        if(d[head[a]] > d[head[b]]) {
            lft = lft + reverse(st.sum(1, 0, MAX_N - 1, in[head[a]], in[head[a]] + place[a]));
            lft = lft + getNow(par[head[a]]);
            a = par[head[a]];
        } else {
            rght = rght + reverse(st.sum(1, 0, MAX_N - 1, in[head[b]], in[head[b]] + place[b]));
            rght = rght + getNow(par[head[b]]);
            b = par[head[b]];
        }
    }

    if(d[a] < d[b]) {
        Node mid = st.sum(1, 0, MAX_N - 1, in[head[a]] + place[a], in[head[b]] + place[b]);
        return (lft + mid + reverse(rght)).sum;
    } else {
        Node mid = st.sum(1, 0, MAX_N - 1, in[head[b]] + place[b], in[head[a]] + place[a]);
        return (rght + mid + reverse(lft)).sum;
    }
}

void updRange(int a, int b, int c) {
    st.upd(1, 0, MAX_N - 1, a, b, c);
}

void subupd(int a, int c) {
    updRange(in[a], out[a], c);
}

void pathupd(int a, int b, int c) {
    while(head[a] != head[b]) {
        if(d[head[a]] > d[head[b]]) {
            updRange(in[head[a]], in[head[a]] + place[a], c);
            a = par[head[a]];
        } else {
            updRange(in[head[b]], in[head[b]] + place[b], c);
            b = par[head[b]];
        }
    }

    if(d[a] < d[b]) {
        updRange(in[head[a]] + place[a], in[head[b]] + place[b], c);
    } else {
        updRange(in[head[b]] + place[b], in[head[a]] + place[a], c);
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n;
    for(int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    dfs(1, 0);
    eul(1, 0, 1, 0);

    for(int i = 1; i <= n; i ++) {
        cin >> arr[i];
        updRange(in[i], in[i], arr[i]);
    }

    int q;
    cin >> q;
    while(q --) {
        int t;
        cin >> t;
        if(t == 1) {
            int a, b, c;
            cin >> a >> b >> c;
            pathupd(a, b, c);
        } else if(t == 2) {
            int a, c;
            cin >> a >> c;
            subupd(a, c);
        } else if(t == 3) {
            int a, b;
            cin >> a >> b;
            cout << path(a, b) << endl;
        }
    }

    return 0;
}

