#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

#define endl "\n"
#define out(x) "[" << #x << "=" << x << "]"

template<class T, class T2>
ostream& operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T>
ostream& operator <<(ostream &out, const vector<T> &x) {
    for(const auto &it : x) {
        out << it << " ";
    }
    return out;
}

struct debug {
    debug() { cerr << "->"; }
    ~debug() { cerr << endl; }

    template<class T>
    debug &operator <<(const T &x) {
        cerr << x << " ";
        return *this;
    }
};
#define dbg debug()

template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
///~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_L = 15;
const int MAX_MAT = MAX_L * MAX_L + MAX_L;

struct Matrix {
    vector<int> tab;

    Matrix() {
        tab = vector<int>(MAX_MAT * MAX_MAT, 0);
    }

    ll get(int x, int y) const {
        return tab[x * MAX_MAT + y];
    }

    void set(int x, int y, int c) {
        tab[x * MAX_MAT + y] = c;
    }

    void add(int x, int y, int c) {
        tab[x * MAX_MAT + y] = (tab[x * MAX_MAT + y] + c) % mod;
    }
};

Matrix one() {
    Matrix ret;

    for(int i = 0; i < MAX_MAT; i ++) {
        ret.set(i, i, 1);
    }
    return ret;
}

Matrix operator *(const Matrix &a, const Matrix &b) {
    Matrix ret;

    for(int i = 0; i < MAX_MAT; i ++) {
        for(int j = 0; j < MAX_MAT; j ++) {
            for(int k = 0; k < MAX_MAT; k ++) {
                ret.add(i, k, a.get(i, j) * b.get(j, k));
            }
        }
    }

    return ret;
}

Matrix fpow(const Matrix &x, ll p) {
    if(p == 0) {
        return one();
    }

    auto ans = fpow(x, p / 2);
    ans = (ans * ans);

    if(p & 1) {
        return ans * x;
    } else {
        return ans;
    }
}

int n, m;

Matrix trans;
Matrix start;

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    string str;
    cin >> str;
    for(int i = 0; i < str.size(); i ++) {
        if(i != str.size() - 1) {
            int ind = (int)(str[i] - 'A') * MAX_L + (int)(str[i + 1] - 'A');
            start.add(ind, ind, 1);
        }
        start.add(MAX_L * MAX_L + (int)(str[i] - 'A'), MAX_L * MAX_L + (int)(str[i] - 'A'), 1) ;
    }

    cin >> n >> m;

    for(int i = 0; i < MAX_L; i ++) {
        trans.set(MAX_L * MAX_L + i, MAX_L * MAX_L + i, 1);
    }

    for(int i = 0; i < m; i ++) {
        char a, b, c;
        cin >> a >> b >> c;

        int ind = (int)(a - 'A') * MAX_L + (int)(b - 'A');
        int ind1 = (int)(a - 'A') * MAX_L + (int)(c - 'A');
        int ind2 = (int)(c - 'A') * MAX_L + (int)(b - 'A');

        trans.set(ind, ind1, 1);
        trans.set(ind, ind2, 1);
        trans.set(ind, MAX_L * MAX_L + (int)(c - 'A'), 1);
    }

    trans = fpow(trans, n);

    for(int i = 0; i < MAX_L; i ++) {
        ll sum = 0;
        for(int j = 0; j < MAX_MAT; j ++) {
            sum = (sum + (start.get(j, j) * trans.get(j, MAX_L * MAX_L + i)));
        }
        cout << (char)('A' + i) << " " << sum << endl;
    }
    for(char c = 'A' + MAX_L; c <= 'Z'; c ++) {
        cout << c << " " << 0 << endl;
    }

    return 0;
}

