#include <bits/stdc++.h>
using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

#define endl "\n"
#define out(x) "[" << #x << "=" << x << "]"

template<class T, class T2>
ostream& operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T>
ostream& operator <<(ostream &out, const vector<T> &x) {
    for(const auto &it : x) {
        out << it << " ";
    }
    return out;
}

struct debug {
    debug() { cerr << "->"; }
    ~debug() { cerr << endl; }

    template<class T>
    debug &operator <<(const T &x) {
        cerr << x << " ";
        return *this;
    }
};
#define dbg debug()

template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
///~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

typedef pair<pair<ll, ll>, ll> cell;
typedef vector<cell> matrix;

void normalize(matrix &ret) {
    sort(ret.begin(), ret.end());
    matrix toret = {};
    for(const auto &it : ret) {
        if(toret.empty() || toret.back().first != it.first) {
            toret.push_back(it);
        } else {
            toret.back().second = (toret.back().second + it.second) % mod;
        }
    }
    ret = toret;
}

map<pair<ll, ll>, ll> prepare(const matrix &a) {
    map<pair<ll, ll>, ll> ret;

    for(const auto &it : a) {
        ret[it.first] = it.second;
    }

    return ret;
}

matrix operator *(const matrix &a, const matrix &b) {
    matrix ret = {};
    for(const auto &it1 : a) {
        for(const auto &it2 : b) {
            if(it1.first.second == it2.first.first) {
                ret.push_back({{it1.first.first, it2.first.second}, it1.second * it2.second % mod});
            }
        }
    }

    normalize(ret);
    return ret;
}

matrix fpow(const matrix &x, ll p) {
    if(p == 1) {
        return x;
    }

    auto ans = fpow(x, p / 2);
    ans = (ans * ans);

    if(p & 1) {
        return ans * x;
    } else {
        return ans;
    }
}

const int MAX_L = 26;
const int MAX_MAT = MAX_L * MAX_L + MAX_L;

matrix trans, start;
int n, m;
string str;
ll cnt[MAX_MAT];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL
    string str;
    cin >> str;
    for(int i = 0; i < str.size(); i ++) {
        if(i != str.size() - 1) {
            int ind = (int)(str[i] - 'A') * MAX_L + (int)(str[i + 1] - 'A');
            cnt[ind] ++;
        }
        cnt[MAX_L * MAX_L + (int)(str[i] - 'A')] ++;
    }

    cin >> n >> m;

    for(int i = 0; i < MAX_L; i ++) {
        trans.push_back({{MAX_L * MAX_L + i, MAX_L * MAX_L + i}, 1});
    }

    for(int i = 0; i < m; i ++) {
        char a, b, c;
        cin >> a >> b >> c;

        int ind = (int)(a - 'A') * MAX_L + (int)(b - 'A');
        int ind1 = (int)(a - 'A') * MAX_L + (int)(c - 'A');
        int ind2 = (int)(c - 'A') * MAX_L + (int)(b - 'A');

        trans.push_back({{ind, ind1}, 1});
        trans.push_back({{ind, ind2}, 1});
        trans.push_back({{ind, MAX_L * MAX_L + (int)(c - 'A')}, 1});
    }

    trans = fpow(trans, n);
    auto mp = prepare(trans);

    for(int i = 0; i < MAX_L; i ++) {
        ll sum = 0;
        for(int j = 0; j < MAX_MAT; j ++) {
            sum = (sum + (cnt[j] * mp[{(ll)j, (ll)(MAX_L * MAX_L + i)}] % mod));
        }
        cout << (char)('A' + i) << " " << sum << endl;
    }
    for(char c = 'A' + MAX_L; c <= 'Z'; c ++) {
        cout << c << " " << 0 << endl;
    }

    return 0;
}

