#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

int const MAXN=1000001;
int n, q, b[MAXN], used[MAXN], lvl[MAXN], a[MAXN], idx=1, path[MAXN], color[MAXN], first[MAXN], root, ans, in[MAXN], out[MAXN], br=1;
vector<int> v[MAXN], cl;

struct edge
{
    int ver, pos;
};

edge tree[2*MAXN];

void make_tree(int idx, int l, int r)
{
    if(l == r)
    {
        tree[idx].ver = a[l];
        tree[idx].pos = l;
        return;
    }
    int mid = (l+r)/2;
    make_tree(idx*2, l, mid);
    make_tree(idx*2+1, mid+1, r);
    if(tree[idx*2].ver < tree[idx*2+1].ver)
    {
        tree[idx].ver = tree[idx*2].ver;
        tree[idx].pos = tree[idx*2].pos;
    }
    else
    {
        tree[idx].ver = tree[idx*2+1].ver;
        tree[idx].pos = tree[idx*2+1].pos;
    }
}

edge query(int idx, int l, int r, int ql, int qr)
{
    if(l > r || ql > r || qr < l) return {100000, 0};
    if(ql <= l && qr >= r)
    {
        return tree[idx];
    }
    int mid = (l+r)/2;
    edge q_l = query(idx*2, l, mid, ql, qr), q_r = query(idx*2+1, mid+1, r, ql, qr);
    if(q_l.ver < q_r.ver)
    {
        return q_l;
    }
    else return q_r;
}

void DFS(int i, int cnt)
{
    lvl[i] = cnt;
    path[idx] = i;
    first[i] = idx;
    in[i] = br;
    idx++;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!lvl[nb])
        {
            br++;
            DFS(nb, cnt+1);
            out[nb] = br;
            path[idx] = i;
            idx++;
        }
    }
}

int lca(int a, int b)
{
    if(first[a] > first[b]) swap(a, b);
    edge qlr = query(1,1,idx, first[a], first[b]);
    return path[qlr.pos];
}

void DFS1(int i, int s, int c)
{
    used[i]=1;
    color[i] = c;
    if(i == s) return;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used[nb] && lvl[nb] == lvl[i]-1)
        {
            used[nb] = 1;
            DFS1(nb, s, c);
        }
    }
}

void DFS3(int i, int s)
{
    used[i]=1;
    if(i == s) return;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used[nb] && lvl[nb] == lvl[i]-1)
        {
            if(color[i] != color[nb]) ans++;
            used[nb] = 1;
            DFS3(nb, s);
        }
    }
}

void read()
{
    int x, y;
    cin>>n;
    for(int i=1;i<n;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    DFS(1, 1);
    out[1]=n;
    for(int i=1;i<idx;i++)
    {
        a[i] = lvl[path[i]];
    }
    idx--;
    make_tree(1,1,idx);
    for(int i=1;i<=n;i++)
    {
        cin>>color[i];
    }
    cin>>q;
    int type, c;
    for(int i=1;i<=q;i++)
    {
        cin>>type>>x>>y;
        if(type == 1)
        {
            cin>>c;
            root = lca(x, y);
            memset(used, 0, sizeof(used));
            DFS1(x, root, c);
            memset(used, 0, sizeof(used));
            DFS1(y, root, c);
        }
        else if(type == 2)
        {
            for(int i=1;i<=n;i++)
            {
                if(in[i] >= in[x] && out[i] <= out[x]) color[i] = y;
            }
        }
        else
        {
            ans=0;
            root = lca(x, y);
            memset(used, 0, sizeof(used));
            DFS3(x, root);
            memset(used, 0, sizeof(used));
            DFS3(y, root);
            cout<<ans<<endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
