#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int to, heavy;
    edge() { }
    edge(int to) :to(to), heavy(0) { }
};

struct other
{
    int x, y;
    other() { }
    other(int x, int y) :x(x), y(y) { }
};

const int N = 100010, K = 100;
int m, level[N], sz[N], path_sz;
vector<edge> ver[N];
int heavy[N], c[N], used[N], frt[N], s[N], parent[N], num[N], in[N];
vector<int> euler, path[K];
other tree[4 * N];
int th[K][N];
//vector< vector<int> > heavy;

void dfs(int v, int p = 0)
{
    parent[v] = p;
    level[v] = level[p] + 1;
    euler.push_back(v);
    for(edge i : ver[v])
    {
        if(i.to != p) dfs(i.to, v), sz[v] = max(sz[v], sz[i.to] + 1), euler.push_back(v);
    }

}

void dfs2(int v, int p = 0)
{
    //cout << v << endl;
    int k = 0;
    for(edge i : ver[v])
    {
        if(i.to != p && sz[i.to] > sz[k]) k = i.to;
        if(i.to != p) dfs2(i.to, v);
    }
    heavy[v] = k;
}

void build_path(int root, int l, int r, int idx)
{
    if(l == r) th[idx][root] = c[path[idx][l]];
    else
    {
        int mid = (l + r) / 2;
        build_path(root * 2, l, mid, idx);
        build_path(root * 2 + 1, mid + 1, r, idx);
        th[idx][root] = th[idx][root * 2] + th[idx][root * 2 + 1];
    }
}

int query_path(int root, int l, int r, int ql, int qr, int idx)
{
    if(ql > qr) return 0;
    if(l == ql && r == qr) return th[idx][root];
    else
    {
        int mid = (l + r) / 2;
        if(qr <= mid) return query_path(root * 2, l, mid, ql, qr, idx);
        if(ql > mid) return query_path(root * 2 + 1, mid + 1, r, ql, qr, idx);
        return query_path(root * 2, l, mid, ql, mid, idx) +
               query_path(root * 2 + 1, mid + 1, r, mid + 1, qr, idx);
    }
}

void build(int root, int l, int r)
{
    if(l == r) tree[root] = other(level[euler[l]], euler[l]);
    else
    {
        int mid = (l + r) / 2;
        build(root * 2, l, mid);
        build(root * 2 + 1, mid + 1, r);
        if(tree[root * 2].x < tree[root * 2 + 1].x) tree[root] = tree[root * 2];
        else tree[root] = tree[root * 2 + 1];
    }
}

other query(int root, int l, int r, int ql, int qr)
{
    if(l == ql && r == qr) return tree[root];
    else
    {
        int mid = (l + r) / 2;
        if(qr <= mid) return query(root * 2, l, mid, ql, qr);
        if(ql > mid) return query(root * 2 + 1, mid + 1, r, ql, qr);
        other i1 = query(root * 2, l, mid, ql, mid);
        other i2 = query(root * 2 + 1, mid + 1, r, mid + 1, qr);
        if(i1.x < i2.x) return i1;
        return i2;
    }
}

void make_lca()
{
    m = (int)euler.size() - 1;
    for(int i = 0; i <= m; ++i)
    {
        if(!frt[euler[i]]) frt[euler[i]] = i;
        //nivo[i] = level[euler[i]];
    }
    frt[1] = 0;
    build(1, 0, m);
}

int get_lca(int i, int j)
{
    if(frt[i] > frt[j]) swap(i, j);
    //cout << frt[i] << " " << frt[j] << endl;
    other k = query(1, 0, m, frt[i], frt[j]);
    return k.y;
}

int solve(int x, int y)
{
    int w = get_lca(x, y);
    //cout << "lca = " << w << endl;
    int k = x, ans = 0;
    while(k != w)
    {
        int idx = num[in[k]];
        if(level[in[k]] > level[w])
        {
            ans += query_path(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]] - 1, idx);
            //for(int i = in[k]; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = in[k];
        }
        else
        {
            ans += query_path(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]] - 1, idx);
            //for(int i = w; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = w;
        }
        if(k != w && k == in[k]) ans += (s[k] == s[parent[k]] ? 0 : 1), k = parent[k];
    }
    k = y;
    while(k != w)
    {
        int idx = num[in[k]];
        if(level[in[k]] > level[w])
        {
            ans += query_path(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]] - 1, idx);
            //for(int i = in[k]; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = in[k];
        }
        else
        {
            ans += query_path(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]] - 1, idx);
            //for(int i = w; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = w;
        }
        if(k != w && k == in[k]) ans += (s[k] == s[parent[k]] ? 0 : 1), k = parent[k];
    }
    return ans;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);

    int q, t, n, x, y;
    cin >> n;
    for(int i = 1; i < n; ++i)
    {
        cin >> x >> y;
        ver[x].push_back(y);
        ver[y].push_back(x);
    }
    for(int i = 1; i <= n; ++i) cin >> s[i];
    //level[1] = 1;
    for(int i = 1; i <= n; ++i) sz[i] = 1;
    dfs(1);
    //for(int i = 0; i <(int)euler.size(); ++i) cout << euler[i] << " ";
    //cout << endl;
    //for(int i = 0; i <(int)euler.size(); ++i) cout << level[euler[i]] << " ";
    //cout << endl;
    dfs2(1);
    //cout << "P" << endl << "HEAVY: ";
    //for(int i = 1; i <= n; ++i) cout << heavy[i] << " ";
    //cout << endl;
    for(int i = 1; i <= n; ++i)
    {
        //cout << i << endl;
        if(!used[i])
        {
            path_sz++;
            int k = i;
            num[k] = path_sz;
            while(k != 0)
            {
                //cout << k << endl;
                path[path_sz].push_back(k);
                used[k] = 1;
                in[k] = i;
                c[k] = (s[k] == s[heavy[k]] ? 0 : 1);
                k = heavy[k];
            }
        }
    }
    //for(int i = 1; i <= n; ++i) cout << c[i] << " ";
    //cout << endl;
    make_lca();
    //cout << "IN = ";
    //for(int i = 1; i <= n; ++i) cout << in[i] << " ";
    //cout << endl;
    //cout << "PPP" << endl;
    for(int i = 1; i <= path_sz; ++i)
    {
        build_path(1, 0, (int)path[i].size() - 1, i);
    }
    //for(int i = 1; i <= path_sz; ++i, cout << endl)
    //    for(int j = 1; j < 20; ++j) cout << th[i][j] << " ";
    //cout << "Y" << endl;
    //for(int i = 0; i <(int)euler.size(); ++i) cout << euler[i] << " ";
    //cout << endl;
    //for(int i = 0; i <(int)euler.size(); ++i) cout << level[euler[i]] << " ";
    //cout << endl;
    cin >> q;
    while(q--)
    {
        cin >> t;
        if(t == 3) cin >> x >> y, cout << solve(x, y) << endl;
    }
    return 0;
}
/*
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
6
3 6 5
3 2 4
3 1 5
3 3 6
3 1 4
3 2 1
*/
