#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int to, heavy;
    edge() { }
    edge(int to) :to(to), heavy(0) { }
};

struct other
{
    int x, y;
    other() { }
    other(int x, int y) :x(x), y(y) { }
};

const int N = 400010, K = 100;
int m, level[N], sz[N], path_sz;
vector<edge> ver[N];
int heavy[N], c[N], used[N], frt[N], s[N], parent[N], num[N], in[N];
vector<int> euler;//, path[K];
other tree[4000000];
int ts[4000000];
vector< vector<int > > th, sh, path, lazy_path;
//int th[K][N];
//vector< vector<int> > heavy;

void dfs(int v, int p = 0)
{
    parent[v] = p;
    level[v] = level[p] + 1;
    euler.push_back(v);
    for(edge i : ver[v])
    {
        if(i.to != p) dfs(i.to, v), sz[v] = max(sz[v], sz[i.to] + 1), euler.push_back(v);
    }

}

void dfs2(int v, int p = 0)
{
    //cout << v << endl;
    int k = 0;
    for(edge i : ver[v])
    {
        if(i.to != p && sz[i.to] > sz[k]) k = i.to;
        if(i.to != p) dfs2(i.to, v);
    }
    heavy[v] = k;
}

void build_path(int root, int l, int r, int idx)
{
    if(l == r)
    {
        th[idx][root] = c[path[idx][l]];
        sh[idx][root] = s[path[idx][l]];
    }
    else
    {
        int mid = (l + r) / 2;
        build_path(root * 2, l, mid, idx);
        build_path(root * 2 + 1, mid + 1, r, idx);
        th[idx][root] = th[idx][root * 2] + th[idx][root * 2 + 1];
    }
}

void push_path(int root, int idx)
{
    if(lazy_path[idx][root])
    {
        th[idx][root * 2] = th[idx][root * 2 + 1] = 0;
        lazy_path[idx][root * 2] = lazy_path[idx][root * 2 + 1] = 1;
        lazy_path[idx][root] = 0;
    }
}

void update_path(int root, int l, int r, int ql, int qr, int idx)
{
    if(ql > qr) return;
    if(l == ql && r == qr)
    {
        lazy_path[idx][root] = 1;
        th[idx][root] = 0;
    }
    else
    {
        push_path(root, idx);
        int mid = (l + r) / 2;
        if(qr <= mid) update_path(root * 2, l, mid, ql, qr, idx);
        else if(ql > mid) update_path(root * 2 + 1, mid + 1, r, ql, qr, idx);
        else update_path(root * 2, l, mid, ql, mid, idx), update_path(root * 2 + 1, mid + 1, r, mid + 1, qr, idx);
        th[idx][root] = th[idx][root * 2] + th[idx][root * 2 + 1];
    }
}

int query_path(int root, int l, int r, int ql, int qr, int idx)
{
    if(ql > qr) return 0;
    if(l == ql && r == qr) return th[idx][root];
    else
    {
        push_path(root, idx);
        int mid = (l + r) / 2;
        if(qr <= mid) return query_path(root * 2, l, mid, ql, qr, idx);
        if(ql > mid) return query_path(root * 2 + 1, mid + 1, r, ql, qr, idx);
        return query_path(root * 2, l, mid, ql, mid, idx) +
               query_path(root * 2 + 1, mid + 1, r, mid + 1, qr, idx);
    }
}

void push_color(int root, int idx)
{
    if(sh[idx][root])
    {
        sh[idx][root * 2] = sh[idx][root * 2 + 1] = sh[idx][root];
        sh[idx][root] = 0;
    }
}

void update_color(int root, int l, int r, int ql, int qr, int x, int idx)
{
    if(l == ql && r == qr)
    {
        //lazy_color[idx][root] = g;
        sh[idx][root] = x;
    }
    else
    {
        push_color(root, idx);
        int mid = (l + r) / 2;
        if(qr <= mid) update_color(root * 2, l, mid, ql, qr, x, idx);
        else if(ql > mid) update_color(root * 2 + 1, mid + 1, r, ql, qr, x, idx);
        else update_color(root * 2, l, mid, ql, mid, x, idx), update_color(root * 2 + 1, mid + 1, r, mid + 1, qr, x, idx);
    }
}

int query_color(int root, int l, int r, int x, int idx)
{
    if(l == r) return sh[idx][root];
    else
    {
        push_color(root, idx);
        int mid = (l + r) / 2;
        if(x <= mid) return query_color(root * 2, l, mid, x, idx);
        else return query_color(root * 2 + 1, mid + 1, r, x, idx);
    }
}

void build(int root, int l, int r)
{
    if(l == r) tree[root] = other(level[euler[l]], euler[l]);
    else
    {
        int mid = (l + r) / 2;
        build(root * 2, l, mid);
        build(root * 2 + 1, mid + 1, r);
        if(tree[root * 2].x < tree[root * 2 + 1].x) tree[root] = tree[root * 2];
        else tree[root] = tree[root * 2 + 1];
    }
}

other query(int root, int l, int r, int ql, int qr)
{
    if(l == ql && r == qr) return tree[root];
    else
    {
        int mid = (l + r) / 2;
        if(qr <= mid) return query(root * 2, l, mid, ql, qr);
        if(ql > mid) return query(root * 2 + 1, mid + 1, r, ql, qr);
        other i1 = query(root * 2, l, mid, ql, mid);
        other i2 = query(root * 2 + 1, mid + 1, r, mid + 1, qr);
        if(i1.x < i2.x) return i1;
        return i2;
    }
}

/*void build_s(int root, int l, int r)
{
    if(l == r) ts[root] = s[l];
    else
    {
        int mid = (l + r) / 2;
        build(root * 2, l, mid);
        build(root * 2 + 1, mid + 1, r);
    }
}

void push_s(int root)
{
    if(ts[root])
    {
        ts[root * 2] = ts[root * 2 + 1] = ts[root];
        ts[root] = 0;
    }
}

void update_s(int root, int l, int r, int ql, int qr, int x)
{
    if(l == ql && r == qr)
    {
        ts[root] = x;
    }
    else
    {
        push_s(root);
        int mid = (l + r) / 2;
        if(qr <= mid) update(root * 2, l, mid, ql, qr, x);
        else if(ql > mid) update(root * 2 + 1, mid + 1, r, ql, qr, x);
        else update(root * 2, l, mid, ql, mid, x), update(root * 2 + 1, mid + 1, r, mid + 1, qr, x);
    }
}

int query_s(int root, int l, int r, int x)
{
    if(l == r) return ts[root];
    else
    {
        push_s(root);
        int mid = (l + r) / 2;
        if(x <= mid) return query_s(root * 2, l, mid, x);
        return query_s(root * 2 + 1, mid + 1, r, x);
    }
}*/

void make_lca()
{
    m = (int)euler.size() - 1;
    for(int i = 0; i <= m; ++i)
    {
        if(!frt[euler[i]]) frt[euler[i]] = i;
        //nivo[i] = level[euler[i]];
    }
    frt[1] = 0;
    build(1, 0, m);
}

int get_lca(int i, int j)
{
    if(frt[i] > frt[j]) swap(i, j);
    //cout << frt[i] << " " << frt[j] << endl;
    other k = query(1, 0, m, frt[i], frt[j]);
    return k.y;
}

int solve(int x, int y)
{
    int w = get_lca(x, y);
    //cout << "lca = " << w << endl;
    int k = x, ans = 0;
    while(k != w)
    {
        int idx = num[in[k]];
        if(level[in[k]] > level[w])
        {
            ans += query_path(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]] - 1, idx);
            //for(int i = in[k]; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = in[k];
        }
        else
        {
            ans += query_path(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]] - 1, idx);
            //for(int i = w; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = w;
        }
        if(k != w && k == in[k])
        {
            int s1 = query_color(1, 0, (int)path[idx].size() - 1, 0, idx);
            int s2 = query_color(1, 0, (int)path[num[in[parent[k]]]].size() - 1, level[parent[k]] - level[in[parent[k]]], num[in[parent[k]]]);//query_s(1, 1, n, parent[k]);
            //cout << k << " " << parent[k] << " -> " << s1 << " " << s2 << endl;
            ans += (s1 == s2 ? 0 : 1);

            k = parent[k];
        }
    }
    k = y;
    while(k != w)
    {
        int idx = num[in[k]];
        if(level[in[k]] > level[w])
        {
            ans += query_path(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]] - 1, idx);
            //for(int i = in[k]; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = in[k];
        }
        else
        {
            ans += query_path(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]] - 1, idx);
            //for(int i = w; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = w;
        }
        if(k != w && k == in[k])
        {
            int s1 = query_color(1, 0, (int)path[idx].size() - 1, 0, idx);
            int s2 = query_color(1, 0, (int)path[num[in[parent[k]]]].size() - 1, level[parent[k]] - level[in[parent[k]]], num[in[parent[k]]]);//query_s(1, 1, n, parent[k]);
            ans += (s1 == s2 ? 0 : 1);

            k = parent[k];
        }
        //if(k != w && k == in[k]) ans += (s[k] == s[parent[k]] ? 0 : 1), k = parent[k];
    }
    return ans;
}

void update1()
{
    int x, y, g;
    cin >> x >> y >> g;
    int w = get_lca(x, y);
    int k = x;
    while(k != w)
    {
        int idx = num[in[k]];
        if(level[in[k]] > level[w])
        {
            update_color(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]], g, idx);
            update_path(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]] - 1, idx);
            if(heavy[k])
            {
                int ss = query_color(1, 0, (int)path[idx].size() - 1, level[k] - level[in[k]] + 1, idx);
                if(ss == g) update_path(1, 0, (int)path[idx].size() - 1, level[k] - level[in[k]], level[k] - level[in[k]], idx);
            }
            //ans += query_path(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]] - 1, idx);
            //for(int i = in[k]; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = in[k];
        }
        else
        {
            update_color(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]], g, idx);
            update_path(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]] - 1, idx);
            if(heavy[k])
            {
                int ss = query_color(1, 0, (int)path[idx].size() - 1, level[k] - level[in[k]] + 1, idx);
                if(ss == g) update_path(1, 0, (int)path[idx].size() - 1, level[k] - level[in[k]], level[k] - level[in[k]], idx);
            }
            //ans += query_path(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]] - 1, idx);
            //for(int i = w; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = w;
        }
        if(k != w && k == in[k])
        {

            //int s1 = query_s(1, 1, n, k);
            //int s2 = query_s(1, 1, n, parent[k]);
            //ans += (s1 == s2 ? 0 : 1);

            k = parent[k];
        }
    }
    k = y;
    while(k != w)
    {
        int idx = num[in[k]];
        if(level[in[k]] > level[w])
        {
            update_color(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]], g, idx);
            update_path(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]] - 1, idx);
            if(heavy[k])
            {
                int ss = query_color(1, 0, (int)path[idx].size() - 1, level[k] - level[in[k]] + 1, idx);
                if(ss == g) update_path(1, 0, (int)path[idx].size() - 1, level[k] - level[in[k]], level[k] - level[in[k]], idx);
            }
            //ans += query_path(1, 0, (int)path[idx].size() - 1, 0, level[k] - level[in[k]] - 1, idx);
            //for(int i = in[k]; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = in[k];
        }
        else
        {
            update_color(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]], g, idx);
            update_path(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]] - 1, idx);
            if(heavy[k])
            {
                int ss = query_color(1, 0, (int)path[idx].size() - 1, level[k] - level[in[k]] + 1, idx);
                if(ss == g) update_path(1, 0, (int)path[idx].size() - 1, level[k] - level[in[k]], level[k] - level[in[k]], idx);
            }
            //ans += query_path(1, 0, (int)path[idx].size() - 1, level[w] - level[in[k]], level[k] - level[in[k]] - 1, idx);
            //for(int i = w; i != k; i = heavy[i]) ans += c[i];
            //ans -= c[k];
            k = w;
        }
        if(k != w && k == in[k])
        {

            //int s1 = query_s(1, 1, n, k);
            //int s2 = query_s(1, 1, n, parent[k]);
            //ans += (s1 == s2 ? 0 : 1);

            k = parent[k];
        }
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);

    int q, t, n, x, y;
    cin >> n;
    for(int i = 1; i < n; ++i)
    {
        cin >> x >> y;
        ver[x].push_back(y);
        ver[y].push_back(x);
    }
    for(int i = 1; i <= n; ++i) cin >> s[i];
    ///build_s(1, 1, n);
    //level[1] = 1;
    for(int i = 1; i <= n; ++i) sz[i] = 1;
    dfs(1);
    //for(int i = 0; i <(int)euler.size(); ++i) cout << euler[i] << " ";
    //cout << endl;
    //for(int i = 0; i <(int)euler.size(); ++i) cout << level[euler[i]] << " ";
    //cout << endl;
    dfs2(1);
    //cout << "P" << endl << "HEAVY: ";
    //for(int i = 1; i <= n; ++i) cout << heavy[i] << " ";
    //cout << endl;
    vector<int> pip;
    path.push_back(pip);
    th.push_back(pip);
    //sp.push_back(pip);
    sh.push_back(pip);
    lazy_path.push_back(pip);
    for(int i = 1; i <= n; ++i)
    {
        //cout << i << endl;
        if(!used[i])
        {
            path_sz++;
            int k = i;
            num[k] = path_sz;
            path.push_back(pip);
            th.push_back(pip);
            lazy_path.push_back(pip);
            //sp.push_back(pip);
            sh.push_back(pip);
            while(k != 0)
            {
                //cout << k << endl;
                for(int j = 0; j < 4; ++j) sh[path_sz].push_back(0), th[path_sz].push_back(0), lazy_path[path_sz].push_back(0);
                path[path_sz].push_back(k);
                //sp[path].push_back()
                used[k] = 1;
                in[k] = i;
                c[k] = (s[k] == s[heavy[k]] ? 0 : 1);
                k = heavy[k];
            }
        }
    }
    //for(int i = 1; i <= n; ++i) cout << c[i] << " ";
    //cout << endl;
    make_lca();
    //cout << "IN = ";
    //for(int i = 1; i <= n; ++i) cout << in[i] << " ";
    //cout << endl;
    //cout << "PPP" << endl;
    for(int i = 1; i <= path_sz; ++i)
    {
        build_path(1, 0, (int)path[i].size() - 1, i);
    }
    //for(int i = 1; i <= path_sz; ++i, cout << endl)
    //    for(int j = 1; j < 20; ++j) cout << th[i][j] << " ";
    //cout << "Y" << endl;
    //for(int i = 0; i <(int)euler.size(); ++i) cout << euler[i] << " ";
    //cout << endl;
    //for(int i = 0; i <(int)euler.size(); ++i) cout << level[euler[i]] << " ";
    //cout << endl;
    cin >> q;
    while(q--)
    {
        cin >> t;
        if(t == 3) cin >> x >> y, cout << solve(x, y) << endl;
        else if(t == 1) update1();
    }
    return 0;
}
/*
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
6
3 6 5
3 2 4
3 1 5
3 3 6
3 1 4
3 2 1
*/
