#include <bits/stdc++.h>
#include "gcd.h"

#pragma GCC optimize "-O3"

#define trace(x) cerr << #x << " = " << endl

using namespace std;

vector<ull> primes;

bool isZero(ull MAX_X) {
    for (ull i = 2; i <= MAX_X; i++) {
        if (query(0, i) != i) {
            return false;
        }
    }

    return true;
}

void generatePrimes(ull MAX_X) {
    vector<bool> sieve(MAX_X + 1, true);
    sieve[0] = sieve[1] = false;
    for (ull i = 2; i * i <= MAX_X; i++) {
        if (sieve[i]) {
            for (ull j = i * i; j <= MAX_X; j += i) {
                sieve[j] = false;
            }
        }
    }

    for (ull i = 2; i <= MAX_X; i++) {
        if (sieve[i]) {
            primes.emplace_back(i);
        }
    }
}

ull play(ull MAX_X) {
    if (primes.empty()) {
        generatePrimes(MAX_X);
    }

    if (isZero(MAX_X)) {
        return 0;
    }

    ull result = 1;
    for (ull i : primes) {
        ull b = i;
        while (b < 2 * MAX_X) {
            ull g = query(0, b);
            if (g == b) {
                result *= i;

                if (result > MAX_X) {
                    break;
                }
            } else {
                break;
            }

            b *= i;
        }

        if (result > MAX_X) {
            result /= i;
            break;
        }
    }

    return result;
}
