#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

string formula;
int n, m;
map<string, char> rules;

void read() {
    cin >> formula;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        string comb;
        char c;
        cin >> comb >> c;

        rules[comb] = c;
    }
}

void solve() {
    int k = formula.size();
    queue<pair<string, int>> pairs;
    map<char, int> cntPoly;
    for (int i = 0; i < k - 1; i++) {
        string Pair = formula.substr(i, 2);
        if (rules.count(Pair)) {
            pairs.emplace(Pair, 1);
        }

        cntPoly[formula[i]]++;
    }
    cntPoly[formula.back()]++;

    while (!pairs.empty()) {
        pair<string, int> now = pairs.front();
        pairs.pop();

        char add = rules[now.first];
        cntPoly[add]++;

        if (cntPoly[add] == MOD) {
            cntPoly[add] = 0;
        }

        if (now.second < n) {
            string l = now.first.substr(0, 1);
            l.push_back(add);

            if (rules.count(l)) {
                pairs.emplace(l, now.second + 1);
            }

            string r = now.first.substr(1, 1);
            r = add + r;

            if (rules.count(r)) {
                pairs.emplace(r, now.second + 1);
            }
        }
    }

    for (char i = 'A'; i <= 'Z'; i++) {
        cout << i << ' ' << cntPoly[i] << endl;
    }
}

int main() {
    setIO();

    read();

    solve();
}

/*
NNCB
2 16
CH B
HH N
CB H
NH C
HB C
HC B
HN C
NN C
BH H
NC B
NB B
BN B
BB N
BC B
CC N
CN C
*/
