#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << endl

using namespace std;

const int BASE = 29;
const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

inline int getHash(const string &s) {
    int hsh = 0, n = s.size();
    for (int i = 0; i < n; i++) {
        hsh = hsh * BASE + (s[i] - 'A' + 1);
    }

    return hsh;
}

string formula;
int n, m;
map<int, char> rules;

void read() {
    cin >> formula;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        string comb;
        char c;
        cin >> comb >> c;

        rules[getHash(comb)] = c;
    }
}

void solve() {
    int k = formula.size();
    map<string, int> cntPairs;
    map<char, int> cntPoly;
    for (int i = 0; i < k - 1; i++) {
        string Pair = formula.substr(i, 2);
        if (rules.count(getHash(Pair))) {
            cntPairs[Pair]++;
        }

        cntPoly[formula[i]]++;
    }
    cntPoly[formula.back()]++;

    for (int i = 0; i < n; i++) {
        map<string, int> next;
        for (auto &p : cntPairs) {
            char add = rules[getHash(p.first)];

            cntPoly[add] +=  (p.second % MOD);
            if (cntPoly[add] >= MOD) {
                cntPoly[add] -= MOD;
            }

            string l = "";
            l.push_back(p.first[0]);
            l.push_back(add);

            if (rules.count(getHash(l))) {
                next[l] += p.second;
                if (next[l] >= MOD) {
                    next[l] -= MOD;
                }
            }

            string r = "";
            r.push_back(add);
            r.push_back(p.first[1]);

            if (rules.count(getHash(r))) {
                next[r] += p.second;
                if (next[r] >= MOD) {
                    next[r] -= MOD;
                }
            }
        }

        cntPairs = next;
    }

    for (char i = 'A'; i <= 'Z'; i++) {
        cout << i << ' ' << cntPoly[i] << endl;
    }
}

int main() {
    setIO();

    read();

    solve();
}

/*
NNCB
2 16
CH B
HH N
CB H
NH C
HB C
HC B
HN C
NN C
BH H
NC B
NB B
BN B
BB N
BC B
CC N
CN C
*/
