#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=1e5+5;
struct vert
{
    int val,lc,rc;
};
int n,q;
vector<int>adj[MAXN];
int par[MAXN];
int depth[MAXN];
int heavy[MAXN];
int head[MAXN];
int pos[MAXN];
int col[MAXN];
vert tree[4*MAXN];
int lazy[4*MAXN];
int dfs(int cur)
{
    int sz=1, ch_sz=0, maxch_sz=0;
    for(int i=0;i<adj[cur].size();i++)
    {
        if(adj[cur][i]==par[cur]) continue;
        par[adj[cur][i]]=cur;
        depth[adj[cur][i]]=depth[cur]+1;
        ch_sz=dfs(adj[cur][i]);
        sz+=ch_sz;
        if(ch_sz>maxch_sz)
        {
            maxch_sz=ch_sz;
            heavy[cur]=adj[cur][i];
        }
    }
    return sz;
}
int ptr_pos=1;
void decompose(int cur,int h)
{
    head[cur]=h;
    pos[cur]=ptr_pos++;
    if(heavy[cur]) decompose(heavy[cur],h);
    for(int i=0;i<adj[cur].size();i++)
    {
        if(adj[cur][i]==par[cur] || adj[cur][i]==heavy[cur]) continue;
        decompose(adj[cur][i], adj[cur][i]);
    }
}
void push(int node,int l,int r)
{
    if(lazy[node])
    {
        tree[node].val=0;
        tree[node].lc=tree[node].rc=lazy[node];
        if(l!=r)
        {
            lazy[2*node]=lazy[node];
            lazy[2*node+1]=lazy[node];
        }
    }
    lazy[node]=0;
}
void update(int node,int l,int r,int b,int e,int col)
{
    push(node,l,r);
    if(e<l || r<b) return;
    if(b<=l && r<=e)
    {
        tree[node].val=0;
        tree[node].lc=tree[node].rc=col;
        if(l!=r)
        {
            lazy[2*node]=col;
            lazy[2*node+1]=col;
        }
        return;
    }
    int mid=(l+r)/2;
    update(2*node,l,mid,b,e,col);
    update(2*node+1,mid+1,r,b,e,col);
    tree[node].val=tree[2*node].val+tree[2*node+1].val;
    if(l!=r && tree[2*node].rc!=tree[2*node+1].lc) tree[node].val++;
    tree[node].lc=tree[2*node].lc;
    tree[node].rc=tree[2*node+1].rc;
}
int query(int node,int l,int r,int b,int e)
{
    push(node,l,r);
    if(e<l || r<b) return 0;
    if(b<=l && r<=e) return tree[node].val;
    int mid=(l+r)/2;
    return query(2*node,l,mid,b,e) + query(2*node+1,mid+1,r,b,e);
}
void upd1(int u,int v,int c)
{
    for(;head[u]!=head[v];v=par[head[v]])
    {
        if(depth[head[u]]>depth[head[v]]) swap(u,v);
        update(1,1,n,pos[head[v]],pos[v],c);
    }
    if(depth[u]>depth[v]) swap(u,v);
    update(1,1,n,pos[u],pos[v],c);
}
int qry(int u,int v)
{
    int ans=0,tmp=0;
    for(;head[u]!=head[v];v=par[head[v]])
    {
        if(depth[head[u]]>depth[head[v]]) swap(u,v);
        tmp=query(1,1,n,pos[head[v]],pos[v]);
        ans+=tmp;
        if(col[par[head[v]]]!=col[head[v]]) ans++;
    }
    if(depth[u]>depth[v]) swap(u,v);
    tmp=query(1,1,n,pos[u],pos[v]);
    ans+=tmp;
    return ans;
}
int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cin>>n;
for(int i=0;i<n-1;i++)
{
    int u,v;
    cin>>u>>v;
    adj[u].push_back(v);
    adj[v].push_back(u);
}
for(int i=1;i<=n;i++)
{
    cin>>col[i];
}
/// if(n<=1000 && q<=1000)
par[1]=0;
depth[1]=0;
dfs(1);
decompose(1,1);
for(int i=1;i<=n;i++)
{
    update(1,1,n,pos[i],pos[i],col[i]);
}
cin>>q;
for(int i=0;i<q;i++)
{
    int type,u,v,c;
    cin>>type;
    if(type==1)
    {
        cin>>u>>v>>c;
        upd1(u,v,c);
    }
    if(type==3)
    {
        cin>>u>>v;
        cout<<qry(u,v)<<endl;
    }
}
return 0;
}
