#include <bits/stdc++.h>
#include <iostream>
//#include "gcd.h"
using namespace std;

typedef unsigned long long ull;

ull query(ull a, ull b);

ull play(ull MAX_X)
{
    ull a = 0, b = (1ll << 29), q;
    while ((q = query(a, b)) != b)
    {
        a += q;
    }
    if (a == 0) a = b;
    return b - a;
}

static const size_t NUM_TRIALS = 4e4;

static ull MAX_X;
static ull MAX_AB;

static ull x;

static ull numQueries;

ull query(ull a, ull b)
{
    if (a < 0 || b <= 0 || a >= MAX_AB || b >= MAX_AB)
    {
        std::cout << "Invalid A or B." << std::endl;
        exit(0);
    }

    ++numQueries;

    a += x;
    while (b != 0)
    {
        ull temp = b;
        b = a % b;
        a = temp;
    }

    return a;
}

static void verifyGuess(ull guess)
{
    if (guess != x)
    {
        std::cout << "Wrong guess." << std::endl;
        exit(0);
    }
}

int main()
{
    std::cin >> MAX_X >> x;

    MAX_AB = MAX_X * 2;
    for (size_t i = 0; i < NUM_TRIALS; ++i)
    {
        ull guess = play(MAX_X);
        verifyGuess(guess);
    }

    double averageQueries = (long double) numQueries / NUM_TRIALS;
    std::cout << "Average queries: " << averageQueries << std::endl;

    return 0;
}
