#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int cnt = 0;
int s[MAXN + 5];
int par[MAXN + 5];
vector<int> G[MAXN + 5];

void DFS1(int u, int p)
{
    par[u] = p;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p) DFS1(v, u);
    }
}

bool DFS2(int u, int p, int to, int c)
{
    if (u == to)
    {
        s[u] = c;
        return true;
    }

    bool flag = false;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p)
        {
            if (DFS2(v, u, to, c)) flag = true;
        }
    }

    if (flag) s[u] = c;
    return flag;
}

void DFS3(int u, int p, int c)
{
    s[u] = c;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p) DFS3(v, u, c);
    }
}

bool DFS4(int u, int p, int to)
{
    if (u == to) return true;

    bool flag = false;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p)
        {
            if (DFS4(v, u, to))
            {
                if (s[v] != s[u]) cnt++;
                flag = true;
            }
        }
    }

    return flag;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }

    DFS1(1, -1);

    int q;
    cin >> q;

    for (int i = 1; i <= q; ++ i)
    {
        int type, u, v, c;
        cin >> type;

        if (type == 1)
        {
            cin >> u >> v >> c;
            DFS2(u, -1, v, c);
        }
        else if (type == 2)
        {
            cin >> u >> c;
            DFS3(u, par[u], c);
        }
        else
        {
            cin >> u >> v;
            cnt = 0;
            DFS4(u, -1, v);
            cout << cnt << endl;
        }
    }

    return 0;
}
