#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int LOG = 17;

int s[MAXN + 5];
int par[MAXN + 5];
int dep[MAXN + 5];
int st[MAXN + 5][LOG + 5];
int cnt[MAXN + 5][LOG + 5];
vector<int> G[MAXN + 5];

void DFS1(int u, int p)
{
    par[u] = p;
    dep[u] = dep[p] + 1;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p) DFS1(v, u);
    }
}

int LCA(int u, int v)
{
    if (dep[u] > dep[v]) swap(u, v);

    int c = 0;
    for (int j = LOG; j >= 0; -- j)
    {
        if (dep[st[v][j]] >= dep[u])
        {
            c += cnt[v][j];
            v = st[v][j];
        }
    }

    for (int j = LOG; j >= 0; -- j)
    {
        if (st[u][j] != st[v][j])
        {
            c += cnt[u][j] + cnt[v][j];
            u = st[u][j];
            v = st[v][j];
        }
    }

    if (u != v) c += cnt[u][0] + cnt[v][0];

    return c;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }

    DFS1(1, 0);

    for (int i = 1; i <= n; ++ i)
    {
        st[i][0] = par[i];
        cnt[i][0] = (s[par[i]] != s[i] ? 1 : 0);
    }

    for (int j = 1; j <= LOG; ++ j)
    {
        for (int i = 1; i <= n; ++ i)
        {
            st[i][j] = st[st[i][j - 1]][j - 1];
            cnt[i][j] = cnt[i][j - 1] + cnt[st[i][j - 1]][j - 1];
        }
    }

    int q;
    cin >> q;

    for (int i = 1; i <= q; ++ i)
    {
        int type, u, v;
        cin >> type >> u >> v;

        cout << LCA(u, v) << endl;
    }

    return 0;
}
