#include <iostream>
#include <string>
#include <vector>
#define endl '\n'
using namespace std;

const int MOD = 1000000007;

int outp[30];

vector< vector<int> > tab, idle, st;

vector< vector<int> > matpow(vector< vector<int> > a, vector< vector<int> > b)
{
    vector< vector<int> > c = idle;
    for (int i = 0; i < a.size(); ++ i)
    {
        for (int j = 0; j < b[0].size(); ++ j)
        {
            for (int k = 0; k < b.size(); ++ k)
            {
                c[i][j] += a[i][k] * b[k][j];
                c[i][j] %= MOD;
            }
        }
    }
    return c;
}

vector< vector<int> > fastpow(vector< vector<int> > a, int b)
{
    vector< vector<int> > ret = fastpow(a, b / 2);
    ret = matpow(ret, ret);
    if (b % 2) ret = matpow(ret, a);
    return ret;
}

long long modpow(long long a, long long b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    string s;
    cin >> s;

    int sz = s.size();

    st.resize(26, vector<int>(1, 0));
    for (int i = 0; i < sz - 1; ++ i)
    {
        st[(s[i] - 'A') * 26 + (s[i + 1] - 'A')][0]++;
    }

    int n, m;
    cin >> n >> m;

    tab.resize(26 * 26, vector<int>(26 * 26, 0));
    idle = tab;
    for (int i = 1; i <= m; ++ i)
    {
        char a, b, c;
        cin >> a >> b >> c;

        tab[(a - 'A') * 26 + (c - 'A')][(a - 'A') * 26 + (b - 'A')]++;
        tab[(c - 'A') * 26 + (b - 'A')][(a - 'A') * 26 + (b - 'A')]++;
    }

    st = matpow(fastpow(tab, n), st);

    for (int j = 1; j <= 26; ++ j)
    {
        for (int k = 1; k <= 26; ++ k)
        {
            outp[j] += st[(j - 1) * 26 + (k - 1)][0];
            outp[j] %= MOD;

            outp[k] += st[(j - 1) * 26 + (k - 1)][0];
            outp[k] %= MOD;
        }
    }

    outp[s[0] - 'A' + 1]++;
    outp[s[0] - 'A' + 1] %= MOD;

    outp[s[sz - 1] - 'A' + 1]++;
    outp[s[sz - 1] - 'A' + 1] %= MOD;

    for (int i = 1; i <= 26; ++ i)
    {
        cout << char(i - 1 + 'A') << " " << (outp[i] * modpow(2, MOD - 2)) % MOD << endl;
    }

    return 0;
}
