#include <iostream>
#include <vector>
using namespace std;
const int MAXN=1e5+10;
vector <int> v[MAXN], ch[MAXN];
int par[MAXN], col[MAXN];
bool used[MAXN];
void dfs(int x, int p) {
    par[x]=p;
    for (auto i:v[x]) {
        if (i==p) continue;
        ch[x].push_back(i);
        dfs(i,x);
    }
}
bool find_path(int x, int y, int c) {
    used[x]=true;
    int kopie=col[x];
    col[x]=c;
    if (x==y) return true;
    for (auto i:v[x]) {
        if (used[i]) continue;
        if (find_path(i,y,c)) return true;
    }
    col[x]=kopie;
    return false;
}
void tree(int x, int c) {
    col[x]=c;
    for (auto i:ch[x]) tree(i,c);
}
pair <int,int> find_ans(int x, int y) {
    ///cout << x << endl;
    used[x]=true;
    if (x==y) return {0,col[x]};
    pair <int,int> p;
    for (auto i:v[x]) {
        if (used[i]) continue;
        p=find_ans(i,y);
        if (p.first!=-1) {
            if (p.second!=col[x]) p.first++;
            p.second=col[x];
            return p;
        }
    }
    return {-1,col[x]};
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q, x, y;
    cin >> n;
    for (int i=0;i<n-1;i++) {
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for (int i=1;i<=n;i++) cin >> col[i];
    dfs(1,-1);
    cin >> q;
    int type, c;
    for (int i=0;i<q;i++) {
        cin >> type >> x >> y;
        for (int j=1;j<=n;j++) used[j]=false;
        if (type==1) {
            cin >> c;
            find_path(x,y,c);
        } else if (type==2) tree(x,y);
        else cout << find_ans(x,y).first << endl;
    }
    return 0;
}
/**
6
1 2
2 6
2 3
3 4
3 5
1 1 3 1 2 1
5
3 6 4
1 6 4 2
3 1 5
2 2 4
3 3 5
**/
