#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=1e5+10;
vector <int> v[MAXN];
int d[MAXN], col[MAXN];
int par[MAXN][20], s[MAXN][20], e[MAXN][20];
void dfs(int x, int p) {
    par[x][0]=p;
    s[x][0]=0;
    e[x][0]=col[x];
    for (auto i:v[x]) {
        if (i==p) continue;
        d[i]=d[x]+1;
        dfs(i,x);
    }
}
void table(int n) {
    for (int i=1;(1<<i)<=n;i++) {
        for (int j=1;j<=n;j++) {
            if (par[j][i-1]==-1) {
                par[j][i]=-1;
                s[j][i]=s[j][i-1];
                e[j][i]=e[j][i-1];
                continue;
            }
            par[j][i]=par[par[j][i-1]][i-1];
            s[j][i]=s[j][i-1]+s[par[j][i-1]][i-1];
            if (e[j][i-1]!=col[par[j][i-1]]) s[j][i]++;
            e[j][i]=e[par[j][i-1]][i-1];
            ///cout << j << ' ' << i << ' ' << par[j][i] << ' ' << s[j][i] << ' ' << e[j][i] << endl;
        }
    }
}
int lca(int x, int y) {
    if (x==y) return 0;
    if (d[x]<d[y]) swap(x,y);
    int res=0;
    for (int i=19;i>=0;i--) {
        if (par[x][i]==-1 || d[par[x][i]]<=d[y]) continue;
        res+=s[x][i];
        if (col[par[x][i]]!=e[x][i]) res++;
        x=par[x][i];
    }
    if (d[x]!=d[y]) {
        if (col[par[x][0]]!=col[x]) res++;
        x=par[x][0];
    }
    if (x==y) return res;
    for (int i=19;i>=0;i--) {
        if (par[x][i]==-1 || par[y][i]==-1 || par[x][i]==par[y][i]) continue;
        res+=s[x][i]+s[y][i];
        if (col[par[x][i]]!=e[x][i]) res++;
        if (col[par[y][i]]!=e[y][i]) res++;
        x=par[x][i];
        y=par[y][i];
    }
    int l=par[x][0];
    if (col[x]!=col[l]) res++;
    if (col[y]!=col[l]) res++;
    return res;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q, x, y;
    cin >> n;
    for (int i=0;i<n-1;i++) {
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for (int i=1;i<=n;i++) cin >> col[i];
    d[1]=0;
    dfs(1,-1);
    table(n);
    cin >> q;
    int type;
    for (int i=0;i<q;i++) {
        cin >> type >> x >> y;
        cout << lca(x,y) << endl;
    }
    return 0;
}
/**
12
1 2
1 3
2 6
2 7
2 8
7 10
8 9
3 4
3 5
4 11
4 12
1 2 1 3 2 1 2 2 1 1 3 1
4
3 9 11
3 4 2
3 6 5
3 10 9
**/
