#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define SMALL 1005
#define MAXN 100005
int br;
vector<int> tree[MAXN];
int color[MAXN], dep[MAXN], par[MAXN];
int way;
int u[MAXN];
void dfs1(int v, int d, int p)
{
    dep[v] = d; u[v] = way; par[v] = p;
    for(int i : tree[v]){
        if(u[i] == way) continue;
        dfs1(i, d + 1, v);
    }
}
void paint(int from, int to, int c)
{
    while(dep[from] > dep[to]){
        color[from] = c; from = par[from];
    }
    while(dep[to] > dep[from]){
        color[to] = c; to = par[to];
    }
    while(from != to){
        color[from] = c; from = par[from];
        color[to] = c; to = par[to];
    }
    color[from] = c;
}
void subtree(int v, int c)
{
    u[v] = way; color[v] = c;
    for(int i : tree[v]){
        if(i == par[v]) continue;
        if(u[i] == way) continue;
        subtree(i, c);
    }
}
int slowfind(int from, int to)
{
    int res = 0;
    if(dep[from] < dep[to]) swap(from, to);
    while(dep[from] > dep[to]){
        int p = par[from]; if(color[p] != color[from]) ++res;
        from = p;
    }
    while(from != to){
        int p = par[from]; if(color[p] != color[from]) ++res;
        from = p;
        p = par[to]; if(color[p] != color[to]) ++res;
        to = p;
    }
    return res;
}
inline void solve1()
{
    for(int i = 0; i < br - 1; ++i){
        int from, to; cin >> from >> to;
        tree[from].push_back(to); tree[to].push_back(from);
    }
    for(int i = 1; i <= br; ++i){
        cin >> color[i];
    }
    ++way;
    dfs1(1, 1, -1);
    int q; cin >> q;
    for(int i = 0; i < q; ++i){
        int t; cin >> t;
        if(t == 1){
            int from, to, c; cin >> from >> to >> c;
            paint(from, to, c);
        }
        else if(t == 2){
            int v, c; cin >> v >> c;
            ++way;
            subtree(v, c);
        }
        else if(t == 3){
            int from, to; cin >> from >> to;
            cout << slowfind(from, to) << endl;
        }
    }
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    way = 8;
    cin >> br;
    if(br < 1005){
        solve1();
    }
    return 0;
}
