#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

struct node{
    int lt;
    int rt;
    int ans;
    int lazy;
};

int n,q,a,b,type,d;
int c[MAXN],dp[MAXN],parent[MAXN],sz[MAXN];
int heavy[MAXN],head[MAXN],pos[MAXN],num,maxs[MAXN];
node tree[4*MAXN];
vector<int> v[MAXN];

void dfs(int x,int p,int dd){

    parent[x]=p;dp[x]=dd;
    sz[x]=1;heavy[x]=0;

    for(int i=0;i<v[x].size();i++){
        if(v[x][i]==p)continue;
        dfs(v[x][i],x,dd+1);
        if(sz[v[x][i]]>sz[heavy[x]]){
            heavy[x]=v[x][i];
        }
        sz[x]+=sz[v[x][i]];
    }
}

void decompose(int x,int h){
    if(x==0)return;

    num++;pos[x]=num;head[x]=h;
    maxs[x]=num;
    decompose(heavy[x],h);
    maxs[x]=max(maxs[x],maxs[heavy[x]]);

    for(int i=0;i<v[x].size();i++){
        if(v[x][i]==parent[x] or v[x][i]==heavy[x])continue;
        decompose(v[x][i],v[x][i]);
        maxs[x]=max(maxs[x],maxs[v[x][i]]);
    }
}

void psh(int v){
    if(tree[v].lazy==0)return;

    tree[2*v].ans=tree[2*v+1].ans=0;
    tree[2*v].lt=tree[2*v+1].lt=tree[v].lt;
    tree[2*v].rt=tree[2*v+1].rt=tree[v].rt;
    tree[2*v].lazy=tree[2*v+1].lazy=tree[v].lazy;

    tree[v].lazy=0;
}

node combine(node fr,node sc){
    if(fr.ans==-1)return sc;
    if(sc.ans==-1)return fr;

    node res={0,0,-1,0};
    res.ans=fr.ans+sc.ans;
    if(fr.rt!=sc.lt)res.ans++;
    res.lt=fr.lt; res.rt=sc.rt;
    res.lazy=0;

    return res;
}

void update(int v,int l,int r,int ll,int rr,int val){
    if(ll>rr)return;

    if(l==ll and r==rr){
        tree[v].lt=tree[v].rt=val;
        tree[v].ans=0;
        tree[v].lazy=val;
    }else{
        psh(v);
        int tt=(l+r)/2;
        update(2*v,l,tt,ll,min(tt,rr),val);
        update(2*v+1,tt+1,r,max(ll,tt+1),rr,val);
        tree[v]=combine(tree[2*v],tree[2*v+1]);
    }
}

node getdiff(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {0,0,-1,0};
    if(l==ll and r==rr){
        return tree[v];
    }else{
        psh(v);
        int tt=(l+r)/2;
        return combine( getdiff(2*v,l,tt,ll,min(tt,rr)) , getdiff(2*v+1,tt+1,r,max(tt+1,ll),rr) );
    }
}

node obr(node x){
    swap(x.lt,x.rt);;
    return x;
}

void upgrade(int a,int b,int d){
    while(head[a]!=head[b]){
        if(dp[head[a]]<dp[head[b]])swap(a,b);

        update(1,1,n,pos[head[a]],pos[a],d);
        a=parent[head[a]];
    }
    if(dp[a]<dp[b])swap(a,b);
    update(1,1,n,pos[b],pos[a],d);
}

int query(int a,int b){
    node lp={0,0,-1,0},rp={0,0,-1,0};
    while(head[a]!=head[b]){
        if(dp[head[a]]>dp[head[b]]){
            lp=combine(lp, obr(getdiff(1,1,n,pos[head[a]],pos[a])) );
            a=parent[head[a]];
        }else{
            rp=combine(getdiff(1,1,n,pos[head[b]],pos[b]) , rp);
            b=parent[head[b]];
        }
    }
    if(dp[a]<dp[b]){
        rp=combine(getdiff(1,1,n,pos[a],pos[b]) , rp);
    }else{
        lp=combine(lp, obr(getdiff(1,1,n,pos[b],pos[a])) );
    }
    lp=combine(lp,rp);
    return lp.ans;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n-1;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    dfs(1,0,0);
    decompose(1,1);

    for(int i=1;i<=n;i++){
        cin>>c[i];
        update(1,1,n,pos[i],pos[i],c[i]);
    }

    cin>>q;
    for(int i=1;i<=q;i++){
        cin>>type;
        if(type==1){
            cin>>a>>b>>d;
            upgrade(a,b,d);
        }else if(type==2){
            cin>>a>>d;
            update(1,1,n,pos[a],maxs[a],d);
        }else{
            cin>>a>>b;
            cout<<query(a,b)<<"\n";
        }
    }

    return 0;
}
