#include <iostream>
#include <vector>
const int maxn = 1e5+10;

int n, q;
int color[maxn], parent[maxn], in[maxn], out[maxn], timer;
std::vector < int > v[maxn];

void dfsInOut(int x, int p)
{
    parent[x] = p;
    in[x] = ++timer;
    for (int i : v[x])
    {
        if (i == p) continue;
        dfsInOut(i, x);
    }
    out[x] = ++timer;
}

bool inSubtree(int x, int y)
{
    return in[x] <= in[y] && out[y] <= out[x];
}

void climbPath(int x, int to, int c)
{
    color[x] = c;
    if (inSubtree(x, to)) return;
    climbPath(parent[x], to, c);
}

void subtreeDfs(int x, int c)
{
    color[x] = c;
    for (int i : v[x])
    {
        if (i == parent[x]) continue;
        subtreeDfs(i, c);
    }
}

int Query(int x, int to)
{
    if (inSubtree(x, to)) return 0;
    return (color[x] != color[parent[x]]) + Query(parent[x], to);
}

void solve()
{
    dfsInOut(1, 0);
    
    std::cin >> q;
    int qtype, x, y, c;
    
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> qtype >> x >> y;
        
        if (qtype == 1)
        {
            std::cin >> c;
            climbPath(x, y, c);
            climbPath(y, x, c);
        }

        if (qtype == 2)
        {
            subtreeDfs(x, y);
        }

        if (qtype == 3)
        {
            int ans = Query(x, y);
            ans += Query(y, x);
            std::cout << ans << '\n';
        }

    }

}

void read()
{
    int x, y;
    std::cin >> n;
    for (int i = 1 ; i <= n-1 ; ++i)
    {
        std::cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    } 
    for (int i = 1 ; i <= n ; ++i) std::cin >> color[i];
}

void fast_io()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fast_io();
    read();
    solve();

    return 0;
}