#include <iostream>
#include <cstring>
#define int long long
const int matSize = 700, maxm = 130, mod = 1e9+7;

std::string beg;
int n, m;
int base[matSize][matSize];
int ans2[matSize][matSize], ans[matSize][matSize];
int buff[matSize][matSize];
int cnt[matSize], after[matSize], output[26];
int rules[matSize];
int realMatSize, l;
bool in[26];
int num[26], revert[26];
char trans[maxm][3];

void copy(int a[][matSize], int b[][matSize])
{
    for (int i = 1 ; i <= realMatSize ; ++i)
    {
        for (int j = 1 ; j <= realMatSize ; ++j)
        {
            a[i][j] = b[i][j];
        }
    }
}

void mult(int a[][matSize], int b[][matSize])
{
    // std::cout << "multiply\n";
    for (int i = 1 ; i <= realMatSize ; ++i)
    {
        for (int j = 1 ; j <= realMatSize ; ++j)
        {
            buff[i][j] = 0;
            for (int k = 1 ; k <= realMatSize ; ++k)
            {
                buff[i][j] = (buff[i][j] + a[i][k] * b[k][j]) % mod;
            }
        }
    }
    copy(a, buff);
}

void power(int n)
{
    // std::cout << "power: " << n << '\n';
    for (int i = 0 ; i < realMatSize ; ++i) ans2[i][i] = 1;
    for (int log = 0 ; (1ll << log) <= n ; ++log)
    {
        // std::cout << "log: " << log << '\n';
        if (n & (1ll << log)) mult(ans2, base);
        mult(base, base);
    }
}

int powerNum(int x, int base)
{
    if (base == 0) return 1;
    if (base & 1) return (x * powerNum(x, base-1)) % mod;
    int res = powerNum(x, base/2);
    return (res*res) % mod;
}

int convert(char a, char b)
{
    return num[a-'A'] * l + num[b-'A'];
}

int to[matSize];

void solve()
{
    if (beg.size() == 1)
    {
        ++output[beg[0]-'A'];
        for (int i = 0 ; i < 26 ; ++i)
        {
            std::cout << char('A' + i) << ' ' << output[i] << '\n'; 
        }
        return;
    }

    memset(num, -1, sizeof(num));
    for (char c : beg)
        in[c-'A'] = 1;

    l = 0;
    for (int i = 0 ; i < 26 ; ++i)
    {
        if (!in[i]) continue;
        ++l;
        num[i] = l-1;
        revert[num[i]] = i;
        // std::cout << "num: " << i << ' ' << num[i] << ' ' << revert[num[i]] << '\n';
    }

    realMatSize = m+1;

    for (int i = 1 ; i <= m ; ++i)
    {
        if (!rules[convert(trans[i][0], trans[i][1])]) rules[convert(trans[i][0], trans[i][1])] = i;
    }

    for (int i = 1 ; i <= m ; ++i)
    {
        if (rules[convert(trans[i][0], trans[i][2])])
        {
            ++base[i][rules[convert(trans[i][0], trans[i][2])]];
        }
        if (rules[convert(trans[i][2], trans[i][1])]) 
        {
            ++base[i][rules[convert(trans[i][2], trans[i][1])]];
        }
        to[convert(trans[i][0], trans[i][1])] = num[trans[i][2]];

    }
 
    power(n);
    for (int i = 1 ; i <= m ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            ans[convert(trans[i][0], trans[i][1])][convert(trans[j][0], trans[j][1])] = ans2[i][j];
        }
    }

    // std::cout << "powered\n";
    for (int i = 0 ; i < beg.size()-1 ; ++i)
    {
        ++cnt[convert(beg[i], beg[i+1])];
    }

    for (int i = 0 ; i < matSize ; ++i)
    {
        for (int j = 0 ; j < matSize ; ++j) 
        {
            if (!rules[convert(trans[i][0], trans[i][2])]) ans[m+1][convert(trans[i][0], trans[i][2])] = (ans[m+1][convert(trans[i][0], trans[i][2])] + ans[convert(trans[i][0], trans[i][1])][i]) % mod;
            if (!rules[convert(trans[i][2], trans[i][1])]) ans[m+1][convert(trans[i][2], trans[i][1])] = (ans[m+1][convert(trans[i][2], trans[i][1])] + ans[convert(trans[i][0], trans[i][1])][i]) % mod;
        }
    }

    for (int i = 0 ; i < matSize ; ++i)
    {
        for (int j = 0 ; j < matSize ; ++j)
        {
            after[j] = (after[j] + cnt[i]*ans[i][j]) % mod;
        }
    }

    for (int i = 0 ; i < matSize ; ++i)
    {
        if (after[i] == 0) continue; 
        output[revert[i/l]] += after[i];
        output[revert[i%l]] += after[i];
        if (output[revert[i/l]] >= mod) output[revert[i/l]] -= mod;
        if (output[revert[i%l]] >= mod) output[revert[i%l]] -= mod;
    }

    // std::cout << "curr: " << beg.front() << ' ' << beg.back() << ' ' << output[beg.front()-'A'] << ' ' << output[beg.back()-'A'] << '\n';
    ++output[beg.front()-'A'];
    ++output[beg.back()-'A'];

    for (int i = 0 ; i < 26 ; ++i)
    {
        std::cout << char('A' + i) << ' ' << (in[i] ? (output[i] * powerNum(2, mod-2)) % mod : 0) << '\n';
    }
}

void read()
{
    std::cin >> beg;
    std::cin >> n >> m;
    for (int i = 1 ; i <= m ; ++i)
    {
        char c[2], a, b, res;
        std::cin >> c >> res;
        a = c[0]; b = c[1];
        in[a-'A'] = 1;
        in[b-'A'] = 1;
        in[res-'A'] = 1;
        trans[i][0] = a;
        trans[i][1] = b;
        trans[i][2] = res;
    } 
}

void fast_io()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fast_io();
    read();
    solve();

    return 0;
}