#include <iostream>
#include <vector>
using namespace std;
vector<int> susedi[100000], children[100000];
int color[100000];
int death[100000];
int parent[100000];
int changes_from_root[100000];
void bfs(int now, int from, int d) {
    death[now] = d;
    if (now == 0) {
        changes_from_root[now] = 0;
    } else {
        if (color[now] == color[from]) {
            changes_from_root[now] = changes_from_root[from];
        } else {
            changes_from_root[now] = changes_from_root[from] + 1;
        }
    }
    for (auto curr : susedi[now]) {
        if (curr != from) {
            children[now].push_back(curr);
            parent[curr] = now;
            bfs(curr, now, d + 1);
        }
    }
}
int lca(int a, int b) {
    if (death[a] > death[b]) {
        return lca(parent[a], b);
    }
    if (death[b] > death[a]) {
        return lca(a, parent[b]);
    }
    if (a == b) {
        return a;
    }
    return lca(parent[a], parent[b]);
}
bool q1(int s, int f, int from, int c) {
    if (s == f) {
        color[s] = c;
        return true;
    }
    for (auto curr : susedi[s]) {
        if (curr != from && q1(curr, f, s, c)) {
            color[s] = c;
            return true;
        }
    }
    return false;
}
void q2(int s, int c) {
    color[s] = c;
    for (auto curr : children[s]) {
        q2(curr, c);
    }
}
//int q3(int s, int f, int from) {
//    return changes_from_root[s] + changes_from_root[f] - changes_from_root[lca(s, f)]
//    if (s == f) {
//        return 1;
//    }
//    for (auto curr : susedi[s]) {
//        if (curr != from) {
//            int yes = q3(curr, f, s);
//            if (yes > 0) {
//                if (color[curr] != color[s]) {
//                    return 1 + yes;
//                } else {
//                    return yes;
//                }
//            }
//        }
//    }
//    return 0;
//}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        susedi[a].push_back(b);
        susedi[b].push_back(a);
    }
    for (int i = 0; i < n; i++) {
        cin >> color[i];
    }
    bfs(0, -1, 0);
    cin >> m;
    for (int i = 0; i < m; i++) {
        int q;
        cin >> q;
        if (q == 1) {
            int a, b, c;
            cin >> a >> b >> c;
            a--;
            b--;
            if(q1(a, b, -1, c)){};
        }
        if (q == 2) {
            int a, c;
            cin >> a >> c;
            a--;
            q2(a, c);
        }
        if (q == 3) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            cout << changes_from_root[a] + changes_from_root[b] - 2 * changes_from_root[lca(a, b)] << endl;
        }
    }
    return 0;
}
