#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const int maxn = 2e5 + 10, maxlog = 20;

int n, q, c[maxn], lvl[maxn], s[2 * maxn], in[maxn], timer;
int par[maxn], depth[maxn];
vector < int > g[maxn];

void dfs(int v, int p)
{
    par[v] = p;
    in[v] = ++ timer;
    s[timer] = v;
    for (int i = 0; i < g[v].size(); i ++)
    {
        int u = g[v][i];
        if (u == p)
            continue;

        lvl[u] = lvl[v] + 1;
        depth[u] = depth[v];
        if (c[u] != c[v])
            depth[u] ++;

        dfs(u, v);

        s[++ timer] = v;
    }
}

int dp[maxlog][maxn * 2], lg[maxn * 2];
void build_sparse_table()
{
    for (int i = 1; i <= timer; i ++)
        lg[i] = lg[i / 2] + 1;

    for (int i = 1; i <= timer; i ++)
        dp[0][i] = s[i];

    for (int j = 1; j < lg[timer]; j ++)
        for (int i = 1; i <= timer - (1 << j) + 1; i ++)
        {
            dp[j][i] = dp[j - 1][i];
            if (lvl[dp[j - 1][i + (1 << (j - 1))]] < lvl[dp[j][i]])
                dp[j][i] =dp[j - 1][i + (1 << (j - 1))];
        }

    /**for (int j = 0; j < lg[timer]; j ++, cout << endl)
        for (int i = 1; i <= timer; i ++)
        cout << dp[j][i] << " ";
    cout << endl;*/
}

int lca_query(int a, int b)
{
    int l = in[a], r = in[b];
    if (l > r)
        swap(l, r);
    int len = lg[r - l + 1] - 1;
    int ans = dp[len][l];
    if (lvl[dp[len][r - (1 << len) + 1]] < lvl[ans])
        ans = dp[len][r - (1 << len) + 1];
    return ans;
}

void recolor(int v, int p)
{
    c[v] = p;
    for (int i = 0; i < g[v].size(); i ++)
    {
        int u = g[v][i];
        if (u == par[v])
            continue;
        recolor(u, p);
    }
}

void solve()
{
    cin >> n;
    for (int i = 1; i < n; i ++)
    {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 1; i <= n; i ++)
        cin >> c[i];

    dfs(1, -1);
    build_sparse_table();

    cin >> q;
    if (n <= 1000 && q <= 1000)
    {
        for (int i = 1; i <= q; i ++)
        {
            int type, v, u, p;
            cin >> type;
            if (type == 1)
            {
                cin >> v >> u >> p;
                int lca = lca_query(v, u);
                while(v != lca)
                {
                    c[v] = p;
                    v = par[v];
                }
                while(u != lca)
                {
                    c[u] = p;
                    u = par[u];
                }
                c[lca] = p;
            }
            else
            if (type == 2)
            {
                cin >> v >> p;
                recolor(v, p);
            }
            else
            {
                cin >> v >> u;
                int lca = lca_query(v, u), ans = 0;
                while(v != lca)
                {
                    if (c[v] != c[par[v]])
                        ans ++;
                    v = par[v];
                }
                while(u != lca)
                {
                    if (c[u] != c[par[u]])
                        ans ++;
                    u = par[u];
                }
                cout << ans << endl;
            }
        }
    }
    /**else
    {
        for (int i = 1; i <= q; i ++)
        {
            int type, v, u;
            cin >> type >> v >> u;
            int lca = lca_query(v, u);
            cout << depth[v] + depth[u] - 2 * depth[lca] << endl;
        }
    }*/
}

int main()
{
    speed();
    solve();
    return 0;
}
