#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const int maxn = 2e5 + 10, maxlog = 20;

int n, q, c[maxn], lvl[maxn], s[2 * maxn], in[maxn], timer;
int par[maxn], depth[maxn], sub[maxn], heavy[maxn];
vector < int > g[maxn];

struct node
{
    int diff, lf, rf;

    node()
    {
        diff = 0;
        lf = 0;
        rf = 0;
    }

    node(int _diff, int _lf, int _rf)
    {
        diff = _diff;
        lf = _lf;
        rf = _rf;
    }
};
node merge_node(node nd1, node nd2)
{
    if (nd1.lf == 0)
        return nd2;
    if (nd2.lf == 0)
        return nd1;
    node nd;
    nd.diff = nd1.diff + nd2.diff;
    nd.lf = nd1.lf;
    nd.rf = nd2.rf;
    if (nd1.rf != nd2.lf)
        nd.diff ++;
    return nd;
}
struct chain
{


    vector < int > ver;
    vector < node > tree;
    vector < int > lazy, tag;
    int k;




    void build_tree(int root, int left, int right)
    {
        lazy[root] = tag[root] = 0;
        if (left == right)
        {
            tree[root].diff = 0;
            tree[root].lf = tree[root].rf = c[ver[left]];
            return;
        }

        int mid = (left + right) / 2;
        build_tree(root * 2, left, mid);
        build_tree(root * 2 + 1, mid + 1, right);
        tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
    }

    void push_lazy(int root, int left, int right)
    {
        tree[root].diff = 0;
        tree[root].lf = tree[root].rf = lazy[root];

        if (left != right)
        {
            tag[root * 2] = tag[root * 2 + 1] = 1;
            lazy[root * 2] = lazy[root * 2 + 1] = lazy[root];
        }

        lazy[root] = tag[root] = 0;
    }

    void update(int root, int left, int right, int qleft, int qright, int val)
    {
        if (tag[root])
            push_lazy(root, left, right);
        if (left > qright || right < qleft)
            return;

        if (left >= qleft && right <= qright)
        {
            lazy[root] = val;
            tag[root] = 1;
            push_lazy(root, left, right);
            return;
        }

        int mid = (left + right) / 2;
        update(root * 2, left, mid, qleft, qright, val);
        update(root * 2 + 1, mid + 1, right, qleft, qright, val);

        tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
    }

    node query(int root, int left, int right, int qleft, int qright)
    {
        if (tag[root])
            push_lazy(root, left, right);

        if (left > qright || right < qleft)
            return {0, 0, 0};

        if (left >= qleft && right <= qright)
            return tree[root];

        int mid = (left + right) / 2;
        return merge_node(query(root * 2, left, mid, qleft, qright),
                          query(root * 2 + 1, mid + 1, right, qleft, qright));
    }


};


void dfs(int v, int p)
{
    par[v] = p;
    in[v] = ++ timer;
    s[timer] = v;
    sub[v] = 1;
    int mx = -1;
    for (int i = 0; i < g[v].size(); i ++)
    {
        int u = g[v][i];
        if (u == p)
            continue;

        lvl[u] = lvl[v] + 1;
        depth[u] = depth[v];
        if (c[u] != c[v])
            depth[u] ++;

        dfs(u, v);
        sub[v] += sub[u];
        if (mx == -1 || sub[mx] < sub[u])
            mx = u;

        s[++ timer] = v;
    }

    heavy[v] = mx;
}

int dp[maxlog][maxn * 2], lg[maxn * 2];
void build_sparse_table()
{
    for (int i = 1; i <= timer; i ++)
        lg[i] = lg[i / 2] + 1;

    for (int i = 1; i <= timer; i ++)
        dp[0][i] = s[i];

    for (int j = 1; j < lg[timer]; j ++)
        for (int i = 1; i <= timer - (1 << j) + 1; i ++)
        {
            dp[j][i] = dp[j - 1][i];
            if (lvl[dp[j - 1][i + (1 << (j - 1))]] < lvl[dp[j][i]])
                dp[j][i] =dp[j - 1][i + (1 << (j - 1))];
        }

    /**for (int j = 0; j < lg[timer]; j ++, cout << endl)
        for (int i = 1; i <= timer; i ++)
        cout << dp[j][i] << " ";
    cout << endl;*/
}

int lca_query(int a, int b)
{
    int l = in[a], r = in[b];
    if (l > r)
        swap(l, r);
    int len = lg[r - l + 1] - 1;
    int ans = dp[len][l];
    if (lvl[dp[len][r - (1 << len) + 1]] < lvl[ans])
        ans = dp[len][r - (1 << len) + 1];
    return ans;
}
vector < chain > ch;
int ridx[maxn], ch_pos[maxn];
void recolor(int v, int p)
{
    c[v] = p;
    for (int i = 0; i < g[v].size(); i ++)
    {
        int u = g[v][i];
        if (u == par[v])
            continue;
        recolor(u, p);
    }
}

void hld(int v, int p)
{
    for (int i = 0; i < g[v].size(); i ++)
    {
        int u = g[v][i];
        if (u == p)
            continue;
        if (u != heavy[v])
        {
            chain cc;
            cc.ver.push_back(u);
            ch_pos[u] = 0;
            ridx[u] = ch.size();
            ch.push_back(cc);
        }
        else
        {
            ch_pos[u] = ch[ridx[v]].ver.size();
            ridx[u] = ridx[v];
            ch[ridx[v]].ver.push_back(u);
        }

        hld(u, v);
    }
}

void solve()
{
    cin >> n;
    for (int i = 1; i < n; i ++)
    {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 1; i <= n; i ++)
        cin >> c[i];

    dfs(1, -1);
    build_sparse_table();

    chain cc;
    cc.ver.push_back(1);
    ridx[1] = 0;
    ch_pos[1] = 0;
    ch.push_back(cc);
    hld(1, -1);


    for (int i = 0; i < ch.size(); i ++)
    {
        ch[i].k = ch[i].ver.size();
        ch[i].tree.resize(ch[i].k * 4);
        ch[i].lazy.resize(ch[i].k * 4);
        ch[i].tag.resize(ch[i].k * 4);
        ch[i].build_tree(1, 0, ch[i].k - 1);

    }



    cin >> q;
    for (int i = 1; i <= q; i ++)
    {

        int type;
        cin >> type;
        if (type == 1)
        {
            int v, u, p;
            cin >> v >> u >> p;
            int lca = lca_query(v, u);
            while(ridx[v] != ridx[lca])
            {
                int idx = ridx[v];
                ch[idx].update(1, 0, ch[idx].k - 1, 0, ch_pos[v], p);
                v = par[ch[idx].ver[0]];
            }
            while(ridx[u] != ridx[lca])
            {
                int idx = ridx[u];
                ch[idx].update(1, 0, ch[idx].k - 1, 0, ch_pos[u], p);
                u = par[ch[idx].ver[0]];
            }

            int lt = max(ch_pos[v], ch_pos[u]);
            int idx = ridx[v];
            ch[idx].update(1, 0, ch[idx].k - 1, ch_pos[lca], lt, p);
        }
        else
        {
            int v, u;
            cin >> v >> u;
            int lca = lca_query(v, u), ans = 0, lastv = -1, lastu = -1;
            while(ridx[v] != ridx[lca])
            {
                int idx = ridx[v];
                node nd =ch[idx].query(1, 0, ch[idx].k - 1, 0, ch_pos[v]);
                ans = ans + nd.diff;
                if (nd.rf != lastv && lastv != -1)
                    ans ++;
                lastv = nd.lf;
                v = par[ch[idx].ver[0]];
            }

            while(ridx[u] != ridx[lca])
            {
                int idx = ridx[u];
                node nd =ch[idx].query(1, 0, ch[idx].k - 1, 0, ch_pos[u]);
                ans = ans + nd.diff;
                if (nd.rf != lastu && lastu != -1)
                    ans ++;
                lastu = nd.lf;
                u = par[ch[idx].ver[0]];
            }

           //if (i == 30)
             //   cout << ans << " - " << lastv << " - " << lastu << endl;
            if (v != lca)
            {
                int idx = ridx[v];
                node nd = ch[idx].query(1, 0, ch[idx].k - 1, ch_pos[lca], ch_pos[v]);
                ans = ans + nd.diff;
                if (nd.rf != lastv && lastv != -1)
                    ans ++;
                if (nd.lf != lastu && lastu != -1)
                    ans ++;
            }

            if (u != lca)
            {
                int idx = ridx[u];
                node nd = ch[idx].query(1, 0, ch[idx].k - 1, ch_pos[lca], ch_pos[u]);
                ans = ans + nd.diff;
                if (nd.rf != lastu && lastu != -1)
                    ans ++;
                if (nd.lf != lastv && lastv != -1)
                    ans ++;
            }

            if (v == lca && u == lca)
            {
                int idx = ridx[lca];
                node nd = ch[idx].query(1, 0, ch[idx].k - 1, ch_pos[lca], ch_pos[lca]);
                if (nd.rf != lastv && lastv != -1)
                    ans ++;
                if (nd.rf != lastu && lastu != -1)
                    ans ++;
            }

            //if (i == 30)
              //  cout << v << " " << u << " " << lca << endl;
            cout << ans << endl;
        }
    }



}

int main()
{
    speed();
    //freopen("test.txt", "r", stdin);
    //freopen("out1.txt", "w", stdout);
    solve();
    return 0;
}
/**
10
1 2
2 6
2 3
3 4
3 5
6 7
6 8
8 9
8 10
1 1 3 1 2 1 5 3 2 6
100
1 6 6 5
1 6 5 1
3 5 3
3 6 2
3 2 6
1 3 4 4
3 1 3
3 5 5
3 3 3
3 6 1
1 1 4 6
1 2 2 6
3 4 3
3 4 3
1 2 6 6
3 3 5
3 4 2
1 4 2 5
1 6 3 1
1 5 5 5
3 5 3
1 3 4 3
3 1 4
3 3 4
1 1 5 3
3 5 3
3 5 1
3 3 2
1 5 3 4
3 6 4
1 2 1 1
3 4 3
3 1 6
1 3 5 4
3 6 4
1 1 5 6
3 1 6
3 4 5
1 5 3 4
1 5 5 4
3 6 2
3 2 6
3 4 6
3 2 3
1 1 3 3
1 5 4 1
3 6 1
1 5 6 6
3 3 4
1 4 3 2
1 3 3 1
3 4 1
3 1 5
3 1 6
1 1 3 3
1 2 6 2
3 1 2
3 4 1
3 2 5
3 3 6
3 3 6
3 3 5
1 3 5 6
3 2 3
3 2 4
1 2 4 6
1 3 1 1
1 1 3 6
3 6 3
1 2 1 5
3 5 3
1 5 6 6
1 4 5 4
1 3 1 4
1 1 3 3
3 6 6
1 1 1 6
3 1 3
3 2 6
3 1 5
1 6 3 3
3 4 2
3 1 4
1 4 2 2
1 3 2 5
1 4 4 3
3 6 1
3 6 3
3 5 1
3 2 3
3 2 3
3 1 5
3 6 4
3 5 2
1 2 2 2
3 2 6
3 5 3
3 3 5
3 1 1
1 3 2 6
*/
